/*
	argmacro.h

	% proto-typing macros

	OWL 1.2
	Copyright (c) 1990, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	10/18/90 jmd	pulled out of old oakland.h
	 12/5/90 bkd	changed ifndef NO_PROTO to ifdef __STDC__

	-----------------

	Macros for use in function prototypes.
	If prototyping is not available on a system then they macro out to nothing.
	These macros are no longer used by oakland code.
	They are provided here for compatability with previous versions.
*/

#ifdef __STDC__
/* prototyping available */

#define _arg1(a) 				  	a
#define _arg2(a,b) 			  		a,b
#define _arg3(a,b,c) 			  	a,b,c
#define _arg4(a,b,c,d) 		  		a,b,c,d
#define _arg5(a,b,c,d,e) 		  	a,b,c,d,e
#define _arg6(a,b,c,d,e,f) 	  		a,b,c,d,e,f
#define _arg7(a,b,c,d,e,f,g) 	  	a,b,c,d,e,f,g
#define _arg8(a,b,c,d,e,f,g,h)   	a,b,c,d,e,f,g,h
#define _arg9(a,b,c,d,e,f,g,h,i) 	a,b,c,d,e,f,g,h,i
#define _arg10(a,b,c,d,e,f,g,h,i,j) a,b,c,d,e,f,g,h,i,j

#else
/* prototyping not available */

#define _arg1(a)
#define _arg2(a,b)
#define _arg3(a,b,c)
#define _arg4(a,b,c,d)
#define _arg5(a,b,c,d,e)
#define _arg6(a,b,c,d,e,f)
#define _arg7(a,b,c,d,e,f,g)
#define _arg8(a,b,c,d,e,f,g,h)
#define _arg9(a,b,c,d,e,f,g,h,i)
#define _arg10(a,b,c,d,e,f,g,h,i,j)

#endif

