/*
	commonod.h	11/29/88

	Object primitive definitions.

	by Ted.

	OWL 1.2
	Copyright (c) 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Note:	Object IDs should be between 10 and 999.
			They are used as omalloc tags.

	Revision History:
	-----------------
	10/25/89 jmd	fixed DoRaw macro (removed *)
	11/06/89 jmd	removed DoRaw macro, once and for all!
	12/12/89 jmd	added object name stuff
*/

#ifndef OAK_COMMONOD
#define OAK_COMMONOD
/* -------------------------------------------------------------------------- */

/* The 'common' object: the grandaddy of all objects */

/* common object data */
typedef struct _commonod {
	obj_type self;		/* pointer back to object shell structure */
} common_od;

/* object get data size structure - used as outdata for OBJM_GETDATASIZE msg */

typedef struct _ogds {
	SIZE_T		xdsize;	/* size of public object data */
	SIZE_T		odsize;	/* size of private object data */
	int			id;		/* object ID */
} ogds_struct;

#define commonod_GetSelf(cdd)		((cdd)->self)

/* object name data: used by the object name list */
typedef struct _objname {
	obj_type 	obj;				/* the object associated with a name */
	int 		hits;				/* number of objects sharing a name */

} objname_struct;


/* -------------------------------------------------------------------------- */
#endif

