/*
	cserror.h		2/21/87

	% header for C-scape error numbers.

	These are used by cs_Assert().

	C-scape alloc name numbers
	These are used by omalloc, ofree etc.

	C-scape 3.2
	Copyright (c) 1986, 1987, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 8/17/88 jmd	added name values.
	 9/15/88 jmd	removed vid and stk_ errors.
*/

/* oakland malloc tag values for C-scape */

#define	CSA_FIELD			1000
#define	CSA_MENU			1001
#define	CSA_TOKBUF			1002
#define	CSA_MCREATE			1003
#define	CSA_SED				1004
#define	CSA_FRAME			1005
#define	CSA_FRAMESED		1006
#define	CSA_HELP			1007
#define	CSA_HELPTEXT		1008
#define	CSA_HELPINDEX		1009
#define	CSA_HELPSPACE		1010
#define	CSA_SLUG	 		1011
#define	CSA_SLUGCHILD		1012
#define	CSA_TEXTBUF			1013

#define	CSA_MCOPYFLD		1016
#define	CSA_TEDREADF		1017
#define	CSA_FLDNAME			1018
#define	CSA_SLEDBLANK		1019
#define	CSA_VARBLOCK		1020

/* error numbers */

#define	CS_FLD_C_FLD 	  1		/* "field_Close:  Passed bad field" */
#define	CS_FLD_FC_FLD	  2		/* "field_FirstChar:  Passed bad field" */
#define	CS_FLD_GM_FLD	  3		/* "field_GetMerge:  Passed bad field" */
#define	CS_FLD_GR_FLD	  4		/* "field_GetRecord:  Passed bad field" */
#define	CS_FLD_LC_FLD	  6		/* "field_LastChar:  Passed bad field" */
#define	CS_FLD_NC_FLD	  7		/* "field_NextChar:  Passed bad field" */
#define	CS_FLD_SC_COL    10  	/* "field_SetChar:  Bad field position or field contains no WRITEABLE positions" */
#define	CS_FLD_SC_FLD	 11		/* "field_SetChar:  Passed bad field" */
#define	CS_FLD_SS_FLD	 12		/* "field_SetString:  Passed bad field" */
#define	CS_FLD_FGD_FLD	 13		/* "field_GetData:  Passed bad field" */
#define	CS_FLD_FSD_FLD	 14		/* "field_SetData:  Passed bad field" */

#define	CS_MD_DF1		 20		/* "draw_field(1): illegal call" */
#define	CS_MD_GC_NFP 	 22		/* "goto_char:  Passed negative fieldpos" */
#define	CS_MD_GC_SED 	 23		/* "goto_char:  Passed bad sed" */
#define	CS_MD_OVR_SED	 24		/* "overwrite:  Passed bad sed" */
#define	CS_MD_POP_SED	 25		/* "sed_Pop():  Passed bad sed" */
#define	CS_MD_RF_FNO	 27		/* "refresh_field:  field number out of range" */
#define	CS_MD_RF_NOF	 28		/* "refresh_field:  no fields in sed" */
#define	CS_MD_DRAW_SED	 29		/* "sed_Draw:  Passed bad sed" */
#define	CS_MD_SCR_SED	 30		/* "scroll:  Passed bad sed" */

#define	CS_M_C_MENU		 40		/* "menu_Destroy:  Passed bad menu" */
#define	CS_M_F_MENU	 	 41		/* "menu_Flush:  Passed bad menu" */
#define	CS_M_GDF_FNO	 42		/* "menu_GetDownField:  Passed out of range fieldno" */
#define	CS_M_GDF_MENU	 43		/* "menu_GetDownField:  Passed bad menu" */
#define	CS_M_GLF_FNO	 44		/* "menu_GetLeftField:  Passed out of range fieldno" */
#define	CS_M_GLF_MENU	 45		/* "menu_GetLeftField:  Passed bad menu" */
#define	CS_M_GRF_FNO	 46		/* "menu_GetRightField:  Passed out of range fieldno" */
#define	CS_M_GRF_MENU	 47		/* "menu_GetRightField:  Passed bad menu" */
#define	CS_M_GUF_FNO	 51		/* "menu_GetUpField:  Passed out of range fieldno" */
#define	CS_M_GUF_MENU	 52		/* "menu_GetUpField:  Passed bad menu" */
#define	CS_M_NC_PCTOVF	 53		/* "menu_Printf (next_char) percent buffer overflow" */
#define	CS_M_OK_CLS	 	 54		/* "menu_Ok:  menu has been closed" */
#define	CS_M_P_CLEN	 	 55		/* "menu_Printf()  @c args too long" */
#define	CS_M_P_CONV	 	 56		/* "(menu.c) percent:  unanticipated conversion character" */
#define	CS_M_P_EOL	 	 58		/* "menu_Printf:  Unexpected end of format string" */
#define	CS_M_P_RARG	 	 59		/* "menu_Printf (repeat):  bad arguments" */

#define	CS_M_P_FLEN	 	 60		/* "menu_Printf()  field too long" */
#define	CS_M_P_MENU	 	 61		/* "menu_Printf:  Passed bad menu" */
#define	CS_M_P_PLEN	 	 62		/* "menu_Printf()  @p args too long" */
#define	CS_M_P_RLEN	 	 63		/* "menu_Printf()  repeat args too long" */
#define	CS_M_P_RVAL	 	 64		/* "menu_Printf (repeat):  out of range repeat count" */
#define	CS_M_P_STATE	 65		/* "menu_Printf:  unanticipated state" */
#define	CS_M_SF_MENU	 69		/* "(menu.c) set_field:  passed bad menu" */
#define	CS_M_P_ATA	 	 70		/* "menu_Printf: Missing '[' in @a command" */
#define	CS_M_P_ALEN	 	 71		/* "menu_Printf()  @a args too long" */
#define	CS_M_P_AT	 	 74		/* "menu_Printf: Bad '@' command" */
#define	CS_M_P_ATP	 	 75		/* "menu_Printf: Missing '[' in @p command" */
#define	CS_M_P_ATC	 	 76		/* "menu_Printf: Missing '[' in @c command" */
#define	CS_M_P_ATF	 	 77		/* "menu_Printf: Missing '[' in @f command" */
#define	CS_M_P_NAME	     79 	/* "menu_Printf: field name too long" */

#define	CS_M_MF_MENU	 80		/* "menu_MoveField: passed bad menu" */
#define	CS_M_MF_FNO		 81		/* "menu_MoveField: passed bad fieldno" */
#define	CS_M_DF_MENU	 82		/* "menu_DeleteField: passed bad menu" */
#define	CS_M_DF_FNO		 83		/* "menu_DeleteField: passed bad fieldno" */
#define	CS_M_DR_MENU	 84		/* "menu_DeleteRows: passed bad menu" */
#define	CS_M_DR_ARG		 85		/* "menu_DeleteRows: passed bad args" */
#define	CS_M_IR_MENU	 86		/* "menu_InsertRows: passed bad menu" */
#define	CS_M_IR_ARG		 87		/* "menu_InsertRows: passed bad args" */
#define	CS_M_STB_MENU	 88		/* "menu_SetTB: passed bad menu" */
#define	CS_M_STB_TEXT	 89		/* "menu_SetTB: passed bad text" */

#define	CS_M_SWF_MENU	 90		/* "menu_SwapFields: passed bad menu" */
#define	CS_M_SWF_ARG	 91		/* "menu_SwapFields: passed bad args" */

#define	CS_SD_CLR_SED	100		/* "sed_Clear:  Passed bad sed" */
#define	CS_SD_C_SED		101 	/* "sed_Close:  passed bad sed" */
#define	CS_SD_DC_SED	102		/* "sed_DecChar:  passed bad sed" */
#define	CS_SD_DF_SED	103		/* "sed_DecField:  passed bad sed" */
#define	CS_SD_GC_PTR	104		/* "sed_GetColors:  passed bad pointers" */
#define	CS_SD_GC_SED 	105 	/* "sed_GetColors:  Passed bad sed" */
#define	CS_SD_GFF_SED	106		/* "sed_GotoFirstField:  passed bad sed" */
#define	CS_SD_GLF_SED	107		/* "sed_GotoLastField:  passed bad sed" */
#define	CS_SD_GO_SED	108 	/* "sed_Go:  passed bad sed" */
#define	CS_SD_GP_SED 	109 	/* "sed_GetPosition:  Passed bad sed" */
#define	CS_SD_GTC_BFP	110 	/* "sed_GotoChar:  passed bad field position" */
#define	CS_SD_GTC_LFP	111 	/* "sed_GotoChar:  passed too large field position" */
#define	CS_SD_GTC_SED	112 	/* "sed_GotoChar:  passed bad sed" */
#define	CS_SD_GTF_BFN	113 	/* "sed_GotoField:  passed bad field number" */
#define	CS_SD_GTF_SED	114 	/* "sed_GotoField:  passed bad sed" */
#define	CS_SD_GTO_NF 	115 	/* "sed_Goto:  no fields in sed" */
#define	CS_SD_GTO_NFO	116 	/* "sed_Goto:  Passed negative fieldno" */
#define	CS_SD_GTO_SED	117 	/* "sed_Goto:  Passed bad sed" */
#define	CS_SD_IC_SED	118 	/* "sed_IncChar:  Passed bad sed" */
#define	CS_SD_IF_SED	119 	/* "sed_IncField:  passed bad sed" */
#define	CS_SD_MF_SED	120 	/* "sed_MarkField:  Passed bad sed" */
#define	CS_SD_MGF_DIR	121 	/* "sed_MoveGField:  passed bad direction" */
#define	CS_SD_MGF_SED	122 	/* "sed_MoveGField:  passed bad sed" */
#define	CS_SD_OVR_SED	123 	/* "sed_Overwrite:  passed bad sed" */
#define	CS_SD_OK_SED	124		/* "sed_OK: don't use a closed sed */
#define	CS_SD_PGRT_SED	125 	/* "sed_PageRight: passed bad sed" */
#define	CS_SD_PGDN_SED	126 	/* "sed_PageDown:  passed bad sed" */
#define	CS_SD_PGLT_SED	127 	/* "sed_PageLeft: passed bad sed" */
#define	CS_SD_PGUP_SED	128 	/* "sed_PageUp:  passed bad sed" */
#define	CS_SD_PSHL_SED	129 	/* "sed_PushLeft:  Passed bad sed" */
#define	CS_SD_PSHR_SED	130 	/* "sed_PushRight:  Passed bad sed" */
#define	CS_SD_PULL_SED	131		/* "sed_PullLeft:  Passed bad sed" */
#define	CS_SD_PULR_SED	132 	/* "sed_PullRight:  Passed bad sed" */
#define	CS_SD_RPTF_SED	133 	/* "sed_RepaintField:  Passed bad sed" */
#define	CS_SD_SB_SED	134 	/* "sed_SetBorder:  Passed bad sed" */

#define	CS_SD_SCRA_SED 	136 	/* "scroll_adjust:  bad sed" */
#define	CS_SD_SCRR_SED	137 	/* "sed_ScrollRight:  passed bad sed" */
#define	CS_SD_SCRD_SED	138 	/* "sed_ScrollDown:  passed bad sed" */
#define	CS_SD_SCRL_SED	139 	/* "sed_ScrollLeft:  passed bad sed" */
#define	CS_SD_SCRU_SED	140 	/* "sed_ScrollUp:  passed bad sed" */
#define	CS_SD_SC_SED	141 	/* "sed_SetColors:  Passed bad sed" */
#define	CS_SD_GFC_PTR	142		/* "sed_GetFieldColors:  passed bad pointers" */
#define	CS_SD_GFC_SED 	143 	/* "sed_GetFieldColors:  Passed bad sed" */

#define	CS_SD_SHGT_SED	144 	/* "sed_SetHeight:  Passed bad sed" */
#define	CS_SD_SHGT_NEG	145 	/* "sed_SetHeight:  Passed bad height" */
#define	CS_SD_SPOS_SED	146 	/* "sed_SetPosition:  Passed bad sed" */
#define	CS_SD_SR_SED	147 	/* "sed_SetRecord:  Passed bad sed" */
#define	CS_SD_SPOS_NEG	148 	/* "sed_SetPosition:  Passed negative position" */

#define	CS_SD_SWID_SED	149 	/* "sed_SetWidth:  Passed bad sed" */
#define	CS_SD_SWID_NEG	150 	/* "sed_SetWidth:  Passed bad width" */

#define	CS_TB_C_TB		170		/* "tb_Close:  Passed bad textbuf" */
#define	CS_TB_FL_BBC	171		/* "tb_FindLine:  bad block chain" */

#define	CS_TB_DL_TB		172		/* "tb_DrawLines:  Passed bad textbuf" */
#define	CS_TB_P_OOR		175		/* "tb_Puts:  passed out of range coords" */
#define	CS_TB_P_TB		176		/* "tb_Puts:  Passed bad textbuf" */
#define	CS_TB_SD_TB		178		/* "tb_SetData:  Passed bad textbuf" */

#define	CS_TD_MM		179		/* "no ted move_method set" */


#define	CS_BOB_NOSLED	180		/* "sled: field func doesn't support sleds" */

#define	CS_SFLS_SFILE	190		/* "sfile_LoadSed: passed bad sfile" */
#define	CS_SFC_SFILE	191		/* "sfile_Close: passed bad sfile" */




