/*
	dpref.h

	% display preferences

	1/18/90 by Ted.

	OWL 1.2
	Copyright (c) 1990 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 5/03/90 jmd 	Added meta key elements to dpref structure
	 5/12/90 jmd 	Changed scancodes to ints
	 7/07/90 pmcm	Added BJ's softflow flag and macros
	10/11/90 ted	Added pccbrk element.
*/
/* -------------------------------------------------------------------------- */

typedef struct _dpref {
	int 	colswanted;		/* number of char. rows and cols on display that */
	int 	rowswanted;		/* disp_Init and ResizeWins should try to arrange */

	boolean resizewins;		/* Flag for resizing wins when disp win is resized */

	int		altmeta;		/* Meta key for generating alt key scancodes   */
	int		ctrlmeta;		/* Meta key for generating ctrl key scancodes  */

	boolean softflow;		/* Flag to tell disp_Init whether to enable
								^S and ^Q keys to affect terminal I/O */
	boolean pccbrk;			/* Flag to stub DOS ctrl-break handlers and return
								the KEY_SIGNAL scancode instead */
} dpref_struct;

OEXTERN dpref_struct curr_dprefstruc;
#define curr_dpref 	(&curr_dprefstruc)

#define dp_GetRowsWanted()			(curr_dpref->rowswanted)
#define dp_SetRowsWanted(r)			(curr_dpref->rowswanted = (r))
#define dp_GetColsWanted()			(curr_dpref->colswanted)
#define dp_SetColsWanted(c)			(curr_dpref->colswanted = (c))

#define dp_GetResizeWins()			(curr_dpref->resizewins)
#define dp_SetResizeWins(rw)		(curr_dpref->resizewins = (rw))

#define dp_GetAltMetaKey()			(curr_dpref->altmeta)
#define dp_SetAltMetaKey(a)			(curr_dpref->altmeta = (a))

#define dp_GetCtrlMetaKey()			(curr_dpref->ctrlmeta)
#define dp_SetCtrlMetaKey(c)	   	(curr_dpref->ctrlmeta = (c))

#define dp_GetSoftflow()			(curr_dpref->softflow)
#define dp_SetSoftflow(sf)			(curr_dpref->softflow = (sf))

#define dp_GetPcCbrk()				(curr_dpref->pccbrk)
#define dp_SetPcCbrk(cb)			(curr_dpref->pccbrk = (cb))
/* -------------------------------------------------------------------------- */

