/*
	fnfunc.h

	% private header for field functions

	This file contains the definition for the
	functions contained in the field functions structures.

	C-scape 3.2
	Copyright (c) 1986-1990, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	12/21/89 jmd	fixed declaration of strtrans
	 2/14/90 mla	added radio funcs
	 3/24/90 jmd	added sfilter_func define
	 3/28/90 jmd	ansi-fied
	 6/10/90 mla	changed fndecpt stuff
	 7/30/90 jmd	changed fndecpt stuff back, added fnfixdp stuff
	 8/05/90 jdc	added secure_fexit
*/

/*** misc utils ***/

/* FNCNTRY.C */
extern char    *strtrans(char *string, int letter, int replace);

/* FNCOMMA.C */
extern char     *strcomma(char *s);
extern char     *strnocomma(char *s);

/* FNDECPT.C */
extern char 	*strdecp(char *s, int pos);
extern char 	*strnodecp(char *s);

/* FNFIXDP.C */
extern char    *strfixdp(char *s, int pos, int len);

/* FNHEX.C */
extern char    *strhex(char *s);

/*** numeric funcs ***/

/* FNNUM.C */
extern void     num_fenter(sed_type sed);
extern void     num_fkey(sed_type sed);
extern char    *strminus(char *s);
extern int      digit_count(char *str);
extern void     clear_field(sed_type sed);

/* FNPNUM.C */
extern void     pnum_fkey(sed_type sed);

/*** bob funcs (FNBOB.C) ***/
extern void     bob_fkey(sed_type sed);

/*** int_funcs (FNINT.C) ***/
extern boolean  int_fexit(sed_type sed);
extern void     int_senter(sed_type sed, int fieldno);
extern void     int_sexit(sed_type sed, int fieldno);

/*** pint_funcs (FNPNUM.C) ***/

/*** hex_funcs (FNHEX.C) ***/
extern boolean  hex_fexit(sed_type sed);
extern void     hex_fkey(sed_type sed);
extern void     hex_senter(sed_type sed, int fieldno);
extern void     hex_sexit(sed_type sed, int fieldno);

/*** long_funcs (FNLONG.C) ***/
extern boolean  long_fexit(sed_type sed);
extern void     long_senter(sed_type sed, int fieldno);
extern void     long_sexit(sed_type sed, int fieldno);


/*** clong_funcs (FNCLONG.C) ***/
extern boolean  clong_fexit(sed_type sed);
extern void     clong_fkey(sed_type sed);
extern void     clong_senter(sed_type sed, int fieldno);
extern void     clong_sexit(sed_type sed, int fieldno);

/*** money_funcs (FNMONEY.C) ***/
extern boolean  money_fexit(sed_type sed);
extern void     money_fkey(sed_type sed);
extern void     money_senter(sed_type sed, int fieldno);
extern void     money_sexit(sed_type sed, int fieldno);

/*** cmoney_funcs (FNCMONEY.C) ***/
extern boolean  cmoney_fexit(sed_type sed);
extern void     cmoney_fkey(sed_type sed);
extern void     cmoney_senter(sed_type sed, int fieldno);
extern void     cmoney_sexit(sed_type sed, int fieldno);

/*** string_funcs (FNSTRING.C) ***/
extern boolean  string_fexit(sed_type sed);
extern void     string_fkey(sed_type sed);
extern void     string_senter(sed_type sed, int fieldno);
extern void     string_sexit(sed_type sed, int fieldno);

/*** alpha_funcs (FNALPHA.C) ***/
extern void     alpha_fkey(sed_type sed);

/*** digit_funcs (FNDIGIT.C) ***/
extern void     digit_fkey(sed_type sed);

/*** char_funcs (FNCHAR.C) ***/
extern void     char_fkey(sed_type sed);
extern void     char_senter(sed_type sed, int fieldno);
extern void     char_sexit(sed_type sed, int fieldno);

/*** double_funcs (FNDOUBLE.C) ***/
extern void     double_fenter(sed_type sed);
extern boolean  double_fexit(sed_type sed);
extern void     double_fkey(sed_type sed);
extern void     double_senter(sed_type sed, int fieldno);
extern void     double_sexit(sed_type sed, int fieldno);

/*** secure_funcs (FNSECURE.C) ***/
extern void     secure_fkey(sed_type sed);
extern void     secure_senter(sed_type sed, int fieldno);
extern boolean  secure_fexit(sed_type sed);

/*** range_funcs (FNRANGE.C) ***/
extern void     range_fkey(sed_type sed);
extern void     range_senter(sed_type sed, int fieldno);

/*** yesno_funcs (FNYESNO.C) ***/
extern boolean  yesno_fexit(sed_type sed);
extern void     yesno_fkey(sed_type sed);
extern void     yesno_senter(sed_type sed, int fieldno);
extern void     yesno_sexit(sed_type sed, int fieldno);

/*** select_funcs (FNSELECT.C) ***/
extern void     select_fkey(sed_type sed);
extern void     select_senter(sed_type sed, int fieldno);

/*** menu_funcs (FNMENU.C) ***/
extern void     menu_fkey(sed_type sed);

/*** gmenu_funcs (FNMENU.C) ***/
extern void     gmenu_fkey(sed_type sed);

/*** click funcs (FNMENU.C) ***/
extern void     click_fkey(sed_type sed);

/*** sint_funcs (FNSINT.C) ***/
extern void     sint_fkey(sed_type sed);
extern void     sint_senter(sed_type sed, int fieldno);
extern void     sint_sexit(sed_type sed, int fieldno);

/*** slong_funcs (FNSLONG.C) ***/
extern void     slong_senter(sed_type sed, int fieldno);
extern void     slong_sexit(sed_type sed, int fieldno);

/*** sfloat_funcs (FNSFLOAT.C) ***/
extern boolean  sfloat_fexit(sed_type sed);
extern void     sfloat_senter(sed_type sed, int fieldno);
extern void     sfloat_sexit(sed_type sed, int fieldno);

/*** sdouble_funcs (FNSDOUBL.C) ***/
extern boolean  sdouble_fexit(sed_type sed);
extern void     sdouble_fkey(sed_type sed);
extern void     sdouble_senter(sed_type sed, int fieldno);
extern void     sdouble_sexit(sed_type sed, int fieldno);

/*** mark_funcs (FNMARK.C) ***/
extern void     mark_fkey(sed_type sed);
extern void     mark_senter(sed_type sed, int fieldno);
extern void     mark_sexit(sed_type sed, int fieldno);

/*** check_funcs (FNCHECK.C) ***/
extern void     check_fkey(sed_type sed);
extern void     check_senter(sed_type sed, int fieldno);
extern void     check_sexit(sed_type sed, int fieldno);

/*** ticker_funcs (FNTICKER.C) ***/
extern void     ticker_fkey(sed_type sed);
extern void     ticker_senter(sed_type sed, int fieldno);

/*** xstring_funcs (FNXSTR.C) ***/
extern void     xstring_fkey(sed_type sed);

/*** toggle funcs (FNTOGGLE.C) ***/
extern void     toggle_fkey(sed_type sed);

/*** togint funcs (FNTOGINT.C) ***/
extern void     togint_fkey(sed_type sed);
extern void     togint_senter(sed_type sed, int fieldno);
extern void     togint_sexit(sed_type sed, int fieldno);

/*** list funcs (FNLIST.C) ***/
extern void     list_fkey(sed_type sed);

/*** date funcs (FNDATE.C) ***/
extern void     date_fkey(sed_type sed);
extern boolean  date_fexit(sed_type sed);
extern void     date_senter(sed_type sed, int fieldno);
extern void     date_sexit(sed_type sed, int fieldno);

/*** time funcs (FNTIME.C) ***/
extern void     time_fkey(sed_type sed);
extern boolean  time_fexit(sed_type sed);
extern void     time_senter(sed_type sed, int fieldno);
extern void     time_sexit(sed_type sed, int fieldno);

/*** radio funcs (FNRADIO.C) ***/
extern void     radio_fkey(sed_type sed);

