/*
	oakaux.h

	% Contains list of oakland alloc aux message values

	OWL 1.2
	Copyright (c) 1990 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 9/24/90 jmd	added range for vuwin and WINA_GO, WINA_SHADOW
*/

/* aux message values ranges
 *
 *		OBJ		   0 -  499
 *		WIN	  	 500 -  999
 *		SED	 	1000 - 1250
 *		VUWIN 	1251 - 1499
 *		SPD     1500 - 1999
 *		CSPOT	2000 - 2499
 *		LNF		2500 - 2999
 *		DATAD	3000 - 3499
 *		USER	10000+    (use AUX_USER(n) macro)
 */


#define	AUX_USER(n)		(10000 + (n))


/* OBJ messages */
#define	AUX_NOMSG			0			/* dummy value */
#define AUX_START			1
#define AUX_END				2
#define AUX_GETVALUE		3  			/* for C-cell */


/* window auxiliary messages */
#define	WINA_STARTGO		500
#define	WINA_ENDGO			501
#define WINA_MOVE			502
#define WINA_RESIZE			503
#define WINA_BORDERCLICK	504
#define WINA_PAINT			505
#define WINA_SHADOW			506
#define	WINA_GO				507

