/*
	oakerror.h		10/5/88

	Oakland windowing layer error numbers.

	OWL 1.2
	Copyright (c) 1986, 1987, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 3/21/89 ted	changed dwmgr calls to wmgr
	 8/30/90 ted	added OE_KB_REENTER & OE_WM_REENTER
	 9/21/90 pmcm	changed oak_errno extern to OEXTERN
*/
/* -------------------------------------------------------------------------- */
/*** error handler ***/

OEXTERN int oak_errno;

#define oak_ClearErrno()	(oak_errno = 0)
#define oak_GetErrno()		(oak_errno)
#define oak_SetErrno(x)		(oak_errno = (x))

/* -------------------------------------------------------------------------- */
/* Error numbers (Note: these values should't be changed) */

#define	OE_GF_DISP		1001	/* "disp_GetFont:         Bad disp" */
#define	OE_WI_DISP		1002	/* "wmgr_Init:            Bad disp" */
#define	OE_WW_DISP		1003	/* "wmgr_Wrapup:          Bad disp" */
#define	OE_WO_DISP		1004	/* "win_PixOpen:          Bad disp" */
#define	OE_WE_DISP		1005	/* "wmgr_ExposePixBox:    Bad disp" */
#define	OE_WE_TDATA		1006	/* "wmgr_ExposePixBox:    Null tiler data pointer" */

#define	OE_KR_DISP		1007	/* "kb_Record:            Bad disp" */
#define	OE_KI_DISP		1008	/* "kb_Idle:              Bad disp" */

#define	OE_GH_DISP		1009	/* "disp_GetHeight:       Bad disp" */
#define	OE_GW_DISP		1010	/* "disp_GetWidth:        Bad disp" */
#define	OE_DC_DISP		1011	/* "disp_Clear:           Bad disp" */
#define	OE_DR_DISP		1012	/* "disp_Repaint:         Bad disp" */
#define	OE_GC_DISP		1013	/* "disp_GetCurrent:      Bad disp" */
#define	OE_SC_DISP		1014	/* "disp_SetCurrent:      Passed bad disp buffer" */

#define	OE_MC_OLD		1015	/* "win_MakeCurrent:      Found bad current win" */
#define	OE_MC_WIN		1016	/* "win_MakeCurrent:      Passed bad win" */
#define	OE_MC_INMOUSE	1017	/* "win_MakeCurrent:      Called within mouse handler" */

#define	OE_WC_WIN		1018	/* "win_Close:            Passed bad win" */
#define	OE_WC_PARENT	1019	/* "win_Class;WINM_CLOSE: Win has bad parent win" */

#define	OE_OO_ODSIZE	1020	/* "obj_Open:             Uninitialized odata size" */
#define	OE_OO_XDSIZE	1021	/* "obj_Open:             Uninitialized xdata size" */
#define	OE_OO_ID		1022	/* "obj_Open:             Uninitialized id" */

#define	OE_KB_REENTER	1023	/* "kb_Read/kb_CheckWait: Called re-entrantly" */
#define	OE_WM_REENTER	1024	/* "win_ReadEvent/win_MouseHoldDownTime/win_MouseDblClick: Called re-entrantly" */

#define	OGL_UNINIT		1100	/* "OGL: call to uninitialized OGL routine" */
/* -------------------------------------------------------------------------- */

