/*
	oakpriv.h

	% Compiler and OS dependent Internal declarations used by Oakland C-tools.

	OWL 1.2
	Copyright (c) 1986-1990, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	12/23/88 jmd	Added OS2 define
	 1/16/89 jmd	Removed limits.h from apollo case
	 4/09/89 ted	Removed OS2 defines. Put them in our makefile instead.
	 8/07/89 jmd	added omemmove to UNIX. move MetaWare define from oakland.h
	 8/18/89 ted	added owl_InitSysWins macro.
	 8/22/89 ted	added USHRT_MAX macro.
	 9/11/89 jmd	added BORDER_CHARS macro.

	12/10/89 jmd	added OVARARG, removed STACK_MINUS
	 2/15/90 jmd	fixed Watcom defines
	 2/29/90 ted	Cleaned up PRIV's.
	 3/03/90 jsm	Added CI defines
	 3/28/90 jmd	ansi-fied
	 4/02/90 ted	Added M6 defines
	 4/13/90 jmd 	moved limits stuff to olimits.h
	 4/30/90 jmd	changed VMS to stdargs
	 6/05/90 gam	Added TSC stuff.
	 6/06/90 ted	Added memmove #define's for Apollo and DG's.
	 6/20/90 ted	Added Watcom 8.0 '386 defines.
	 9/28/90 ted	Added Watcom 8.0 defines.
	10/10/90 ted	added support for TCP Turbo C++ flag.
	10/11/90 pmcm	defined BORDER_CHARS for OAK_VMS
	10/18/90 jmd	added ANSI test to UNIX

	This file depends on a symbol being #define'd for the Compiler or OS.
	See "oakland.h" for the symbol definitions.

	Note:  the BORDER_CHARS macro turns on fancy characters used by 
		   certain borders (such as bd_std).	
*/
/* -------------------------------------------------------------------------- */

#ifdef M6	/*	  	Microsoft C version 5,6.x Dependent Code 	*/
#	ifndef M5
		/* Special stuff for M6.x */
		int _FAR_ _cdecl inp(unsigned);
		int _FAR_ _cdecl outp(unsigned, int);

#		define DIGPRIV	_near
#		define OWLPRIV	_near
#		define CSPRIV	_near
#	else
		/* Special stuff for M5.x */
		int _CDECL inp(unsigned int);
		int _CDECL outp(unsigned int, int);

#		define DIGPRIV	_NEAR
#		define OWLPRIV	_NEAR
#		define CSPRIV	_NEAR
#	endif

#	define BORDER_CHARS
#endif

#ifdef TC	/*		Turbo C Dependent Code		*/
#	define DIGPRIV	near
#	define OWLPRIV	near
#	define CSPRIV	near

#	define BORDER_CHARS
#endif

#ifdef TCP	/*		Turbo C++ Dependent Code		*/
#	define DIGPRIV	near
#	define OWLPRIV	near
#	define CSPRIV	near

#	define BORDER_CHARS
#endif

#ifdef TSC /*  JPI TopSpeed C Dependent Code    */
#	define BORDER_CHARS
#endif

#ifdef CI	/*		Computer Innovations C86 Dependent Code		*/
#	define BORDER_CHARS
#endif

#ifdef LC	/*	  	Lattice C Dependent Code	*/
#	define memmove(dest, src, cnt)		memcpy(dest, src, cnt)

#	define DIGPRIV	near
#	define OWLPRIV	near
#	define CSPRIV	near

#	define BORDER_CHARS
#endif

#ifdef MW	/* MetaWare High C stuff */
	/* OMEMMOVE.C */
	extern VOID	   *omemmove(VOID *dst, VOID *src, SIZE_T cnt);

#	define memmove(dest,src,cnt)	omemmove(dest, src, cnt)

#	define BORDER_CHARS
#endif

#ifdef Z2			/* Zortech 2.0 Dependent Code */
#	include <conio.h>

#	define	BORDER_CHARS
#endif

#ifdef W8		/*	  	Watcom C 8.0 Dependent Code 	*/
#	define DIGPRIV	near
#	define OWLPRIV	near
#	define CSPRIV	near

#	define BORDER_CHARS
#endif

#ifdef W8386		/*	  	Watcom 8.0 '386 Dependent Code 	*/
#	define BORDER_CHARS
#endif

#ifdef OAK_UNIX		/*	  	UNIX Dependent Code */

/* convert memmove to omemmove */

	/* OMEMMOVE.C */
	extern VOID	   *omemmove(VOID *dst, VOID *src, SIZE_T cnt);

#	define memmove(dest,src,cnt)	omemmove(dest, src, cnt)

#	ifndef __STDC__
	/* K&R UNIX compiler */
#	define O_VARARG
#	else
	/* ANSI UNIX compiler */
#	define O_STDARG
#	endif

#endif

#ifdef OAK_APOLLO	/* 	Apollo Dependent Code */

#	define owl_InitSysWins()	gpr_InitSysWins()
	void gpr_InitSysWins(void);

#	define memmove(dest, src, cnt)		memcpy(dest, src, cnt)

#	define O_VARARG

#endif

#ifdef OAK_SUN		/*	  	SUN Dependent Code */
/* convert memmove to memcpy for ANSI compatibility */
#	define memmove(dest, src, cnt)		memcpy(dest, src, cnt)

#	define O_VARARG

#endif

#ifdef OAK_VMS		/*	  	VMS Dependent Code */
	/* convert memmove to omemmove */
	/* OMEMMOVE.C */
	extern VOID	   *omemmove(VOID *dst, VOID *src, SIZE_T cnt);
#	define memmove(dest,src,cnt)	omemmove(dest, src, cnt)

#	define BORDER_CHARS

#	define O_STDARG

#endif

#ifdef OAK_STRATUS		/*	  	STRATUS Dependent Code */
#	define O_VARARG

#endif

#ifdef OAK_DG	/*	  	Data General C Dependent Code	*/
#	define memmove(dest,src,cnt)	omemmove(dest, src, cnt)

#	define O_STACKMINUS
#endif

#ifndef owl_InitSysWins
#	define owl_InitSysWins()
#endif

#ifndef DIGPRIV
#	define DIGPRIV
#endif
#ifndef OWLPRIV
#	define OWLPRIV
#endif
#ifndef CSPRIV
#	define CSPRIV
#endif
/* -------------------------------------------------------------------------- */

