/*
	oaktag.h

	% Contains list of oakland alloc tag values and object ID values.

	OWL 1.2
	Copyright (c) 1986, 1987, 1988 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	11/20/88 jmd	objects now use IDs for tags
	 3/03/89 jdc	removed symlist IDs and added OA_LSYM
	 4/20/89 ted	added ID_BCWIN
	 4/21/89 jmd	removed unused border tags
	 7/28/89 ted	added OA_FRW

	 2/14/90 ted	added OA_DIGFONT
	 4/07/90 pmcm	added ID_BDMOUSE2
	 6/29/90 mla	added ID_ODIR
	 7/19/90 bkd	added OA_KLEX, OA_BTREE
	 8/01/90 jmd	added OA_USER macro
	 8/12/90 bkd	added comment about updating oakmemok.c
	 9/25/90 jmd	added SPDWIN and USERWIN tags
	10/29/90 pmcm	added OA_SMGLINEBUF, OA_SMGTERMCAPBUF tags for VMS DIG
*/

/* tag ranges (first half of each range are tags, second half object IDS*/

/* oakland lib			  10 -  899	*/
/* misc. digs			 900 -  999	*/
/* C-scape lib 			1000 - 1999	*/
/* C-cell lib 			2000 - 2999 */
/* C-spot lib			3000 - 3999	(3000-3100 wins) else objects */
/* LNF lib 				4000 - 4999	*/
/* X lib 				5000 - 5999	*/
/* End user			   10000 - 32K	(use OA_USER macro) */

/* OA_NOTAG is defined in oakalloc.h */

/*** oakland tag values ***/
/* When adding items to this list, don't forget to update oakmemok.c */

#define	OA_USER(n)		(10000 + (n))

#define OA_BDTITLE	    10

#define OA_CMAP			100
#define OA_CMAPBUF		101
#define OA_SAVDISP		102
#define OA_IARR			103
#define OA_IARRA		104
#define OA_LARR			105
#define OA_LARRA		106
#define OA_OBJ			107
#define OA_OCOLMAP		108
#define OA_DIGDATA		109
#define OA_PMAP			110
#define OA_PMAPBUF		111
#define OA_STRWRAP		112
#define OA_TILE			113
#define OA_WIN			114
#define OA_XARR			115
#define OA_XARRA		116
#define OA_VARRAY		117
#define OA_OS2KMDATA	118
#define OA_OGL			119
#define OA_FONT			120
#define OA_VIA			121
#define OA_DIGATTRMAP	122
#define OA_DIGCOLMAP	123
#define OA_FRW			124
#define OA_DIGFONT		125

#define OA_BFILE	   	200
#define	OA_LIST			201
#define	OA_LSYM			202
#define OA_BFPUSH		203

#define	OA_BBLOCK		300
#define	OA_BBDATA		301
#define	OA_BBCHAIN		302
#define	OA_SFILE		303
#define OA_KLEX			304
#define OA_BTREE		305
#define OA_SFTEXT		306

/***	VAX/VMS DIG ***/

#ifdef OAK_VMS
#	define	OA_SMGLINEBUF		900
#	define	OA_SMGTERMCAPBUF	901
#endif 

/*** oakland object IDs ***/

#define ID_COMMON		400

#define ID_BORDER		500
#define ID_BD1		   	501
#define ID_BD123		502
#define ID_BD2			503
#define ID_BDBOX		504
#define ID_BDBOXLIGHT	505
#define ID_BDEDIT		506
#define ID_BDNULL		507
#define ID_BDPLAIN		508
#define ID_BDSTD		509
#define ID_BDTITLE		510
#define ID_BDPROMPT		511
#define ID_BDXREF		512
#define ID_BDSIDEBAR	513
#define ID_BDMOUSE		514
#define ID_BDBAR		515
#define ID_BDHEAD		516
#define ID_BDMOUSE2		517

#define ID_WIN			600
#define ID_BLWIN		601
#define ID_CMWIN		602
#define ID_GRWIN		603
#define ID_NPWIN		604
#define ID_PMWIN		605
#define ID_BCWIN		606
#define ID_MSGWIN		607
#define ID_USERWIN		608

#define ID_SEDWIN		610
#define ID_SLEDWIN		611
#define ID_SPDWIN		620

#define ID_BOB			700
#define ID_UFUNC		703

#define ID_ODIR			706
#define ID_SFTEXT		707
