/*
	olimits.h

	% Oakland limits.h version.  Depends on what compiler is being used.

	OWL 1.2
	Copyright (c) 1990, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 4/13/90 jmd	created
	 4/25/90 ted	Added signed limits for Unix-like cases, consolidated them.
	 6/01/90 jmd	fixed DG case
	 6/05/90 gam	Added TSC stuff.	 
	 6/20/90 ted	Added Watcom 8.0 '386 defines.
	10/18/90 jmd	moved dependencies to oakland.h

	-----------------
	This file depends on the symbol O_NOLIMIT_H
	being #define'd for the Compiler or OS.

	See "oakland.h" for the symbol definitions.
*/

#ifndef O_NOLIMIT_H	 /* default case */
#	include <limits.h>

#else	/* Standard limits for systems with no "limits.h" */

#	define USHRT_MAX	((unsigned short) ~0)	/* max value for unsigned short */
#	define UINT_MAX		((unsigned int) ~0)		/* max value for unsigned int */
#	define INT_MAX		((int) (UINT_MAX/2))	/* max value for signed int */
#	define INT_MIN		((-INT_MAX) - 1)		/* min value for signed int */
#	define ULONG_MAX	((unsigned long) ~(0L))	/* max value for unsigned long */
#	define LONG_MAX		((long) (ULONG_MAX/2))	/* max value for signed long */
#	define LONG_MIN		((-LONG_MAX) - 1)		/* min value for signed long */

#endif

