/*
	os2lc.h

	% OS2 definitions for Lattice C

	11/13/88  by Ted.

	OWL 1.2
	Copyright (c) 1986, 1987, 1988 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
*/

/* -------------------------------------------------------------------------- */
#define IO_WAIT     0
#define IO_NOWAIT   1

#define MAKEUSHORT(l, h) (((unsigned short)(l)) | ((unsigned short)(h)) << 8)

typedef struct {
	unsigned short	row;
	unsigned short	col;
	unsigned short	cRow;
	unsigned short	cCol;
} NOPTRRECT;

typedef struct {
	byte			hours;
	byte			minutes;
	byte			seconds;
	byte			hundredths;
	byte			day;
	byte			month;
	unsigned short  year;
	short			timezone;
	byte			weekday;
} DATETIME;

typedef unsigned short	HKBD;
typedef unsigned short	HVIO;
typedef unsigned short	HMOU;
typedef unsigned long  *HSEM;	/* not for system semaphores */
typedef unsigned short	TID;
typedef unsigned short	PID;

typedef struct {
	unsigned short	zero;
	HSEM			hsem;
} MUXSEM;

#define DEFINEMUXSEMLIST(name, size) \
	struct {						\
	unsigned short	cmxs;			\
	MUXSEM amxs[size];			   	\
} name;

typedef struct {
	byte			chChar;
	byte			chScan;
	byte			fbStatus;
	byte			bNlsShift;
	unsigned short	fsState;
	unsigned long	time;
} KBDKEYINFO;

typedef struct {
	unsigned short	fs;
	unsigned long	Time;
	unsigned short	row;
	unsigned short	col;
}MOUEVENTINFO;

typedef struct {
	unsigned short	cEvents;
	unsigned short	cmaxEvents;
} MOUQUEINFO;

typedef struct {
	PID			pid;
	TID			tid;
	PID			pidParent;
} PIDINFO;
/* -------------------------------------------------------------------------- */

typedef struct {
	byte			*pBuf;
	unsigned long	cb;
	unsigned short	asel[1];
} VIOPHYSBUF;

typedef struct {
	unsigned short	cb;
	byte			fbType;
	byte			color;
	unsigned short	col;
	unsigned short	row;
	unsigned short	hres;
	unsigned short	vres;
	byte			fmt_ID;
	byte			attrib;
} VIOMODEINFO;

#define VGMT_OTHER          0x01
#define VGMT_GRAPHICS       0x02
#define VGMT_DISABLEBURST   0x04

typedef struct {
	unsigned short   yStart;
	unsigned short   cEnd;
	unsigned short   cx;
	unsigned short   attr;
} VIOCURSORINFO;
/* -------------------------------------------------------------------------- */

