/*
	oslist.h

	% symbol list header

	OWL 1.2
	Copyright (c) 1988 - 1990, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 8/09/89 jdc	changed oslist_GetSym to oslist_Get

	12/11/89 jmd	renamed this file
	 1/20/89 jdc	speeded data retrieval
	 3/28/90 jmd	ansi-fied
	 4/23/90 jmdc	added oslist_FindData
	 6/18/90 jdc	made alpha_find public, now FindAlpha
	 7/31/90 jdc	preened
	 9/07/90 jmd	changed some names around
*/

typedef	struct oslist_struct {

	xarray	seqnt;
	iarray	alpha;
	int 	size;

	int 	dsize;		/* size of data element associated with each symbol */

} *oslist_type;

#define	OSLIST_SYMMAXLEN	100
#define	OSLIST_BADNAME		-1

/* OSLIST.C */
extern oslist_type oslist_Open(int size, int data_size);
extern int		oslist_SetSym(oslist_type oslist, char *symbol, VOID *data);
extern char	   *oslist_GetSym(oslist_type oslist, int h);
extern VOID	   *oslist_GetData(oslist_type oslist, int h);
extern void		oslist_SetData(oslist_type oslist, int h, VOID *data);
extern int		oslist_GetAlphaHandle(oslist_type oslist, int a);
extern int		oslist_GetSize(oslist_type oslist);
extern int		oslist_FindHandle(oslist_type oslist, char *symbol);
extern boolean	oslist_FindAlpha(oslist_type oslist, char *name, int *alpha);
extern boolean	oslist_Delete(oslist_type oslist, int h);
extern void		oslist_Close(oslist_type oslist);

#define oslist_GetAlphaSym(oslist, a)	\
	oslist_GetSym(oslist, oslist_GetAlphaHandle(oslist, a))

#define oslist_GetDataSize(oslist)	((oslist)->dsize)

#define oslist_FindData(oslist, name) 	\
	oslist_GetData(oslist, oslist_FindHandle(oslist, name))

