/* 
	pcdir.h -mla

	% oakland MS-DOS file and directory MACROS

	OWL 1.2
	Copyright (c) 1990, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 8/27/90 mla	revised to latest scheme
	10/22/90 mla	added OFILE_PARENTDIR, made OFILE_CURRDIR consistent
	10/24/90 mla	added odir_IsFullSpec
	10/28/90 mla	removed terminating slashes from OFILE_PARENTDIR, CURRDIR
	10/31/90 jmd	remove OFILE_SEPCHAR
*/
/* -------------------------------------------------------------------------- */

/* This file gets included twice from within OAKDIR.H. On the first pass
	"_OAKDIR_" is not defined, and on the second pass it is.
*/
#ifndef _OAKDIR_
#	define OFILE_NAMELEN	13
#	define OFILE_PATHLEN	128
#	define OFILE_ENVSEP		';'
#	define OFILE_WILDCARD	"*.*"
#	define OFILE_CURRDIR	"."
#	define OFILE_PARENTDIR	".."
#else

/* Oakland directory handling functions */
/* PCDIR.C */
extern odir_Open_func(pcdir_Open);
extern odir_Read_func(pcdir_Read);
extern odir_Close_func(pcdir_Close);
extern ofile_Remove_func(pcfile_Remove);

#define odir_Open			pcdir_Open
#define odir_Read			pcdir_Read
#define odir_Close			pcdir_Close
#define ofile_Remove		pcfile_Remove

/* Path name operator functions */
extern odir_Ascend_func(pcdir_Ascend);
extern odir_Descend_func(pcdir_Descend);
extern odir_Split_func(pcdir_Split);
extern odir_Join_func(pcdir_Join);
extern odir_StripCase_func(pcdir_StripCase);
extern odir_GetCurrDir_func(pcdir_GetCurrDir);
#define pcdir_IsFullSpec(s) (*(s) == '\\' || *(s) == ':' ? TRUE : FALSE)

extern ofile_IsValid_func(pcfile_IsValid);
extern odir_IsValid_func(pcdir_IsValid);
extern odir_MakePath_func(pcdir_MakePath);

#define odir_Ascend			pcdir_Ascend
#define odir_Descend		pcdir_Descend
#define odir_Split			pcdir_Split
#define odir_Join			pcdir_Join
#define odir_StripCase		pcdir_StripCase
#define odir_GetCurrDir		pcdir_GetCurrDir
#define odir_IsFullSpec		pcdir_IsFullSpec

#define ofile_IsValid		pcfile_IsValid
#define odir_IsValid		pcdir_IsValid
#define odir_MakePath		pcdir_MakePath
#endif

