/*
	pcxdecl.h

	% declarations for PCX image i/o.

	5/02/89  by Ted.

	OWL 1.2
	Copyright (c) 1989 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 3/28/90 jmd	ansi-fied
	 5/08/90 jmd	added underscores to func macros for vms compiler
*/

#define PCX_FILLER	56

typedef struct _pcxhdr {
	byte 		   mfgr;
	byte 		   version;
	byte 		   encoding;
	byte 		   pixbits;
	unsigned short xmin;
	unsigned short ymin;
	unsigned short xmax;
	unsigned short ymax;

	unsigned short hres;
	unsigned short vres;

	byte 		   rgb[16][3];
	byte 		   reserved;
	byte 		   nplanes;
	unsigned short linebytes;
	unsigned short paltype;		/* 1 := color/bw, 2:= greyscale */
	unsigned short ylines;
	byte 		   filler[PCX_FILLER];
} pcxhdr_struct;

#define pcxunpack_func(fname)		boolean DIGPRIV fname(struct frw_struct *_frw, pcxhdr_struct *_pcxhdr, pmap_type _pmap)
typedef                 boolean (DIGPRIV *pcxunpack_fptr)(struct frw_struct *_frw, pcxhdr_struct *_pcxhdr, pmap_type _pmap);

#define pcxpack_func(fname)			boolean DIGPRIV fname(struct frw_struct *_frw, pmap_type _pmap)
typedef                   boolean (DIGPRIV *pcxpack_fptr)(struct frw_struct *_frw, pmap_type _pmap);
/* -------------------------------------------------------------------------- */

/* PCXLOAD.C */
extern void		DIGPRIV dig_loadpcx(frw_type frw, pmap_type *pmapp, ocolmap_type *cmapp, pcxunpack_fptr unpackpcx);
extern boolean	DIGPRIV pcx_readline(frw_type frw, byte *obuf, unsigned linebytes, unsigned *ocountp);
extern void		DIGPRIV pcx_hdrflip(pcxhdr_struct *pcxhdr);

/* PCXSAVE.C */
extern boolean	DIGPRIV pcx_writeline(frw_type frw, byte *obuf, unsigned linebytes);
extern boolean	DIGPRIV dig_savepcx(frw_type frw, pmap_type pmap, ocolmap_type cmap, pcxpack_fptr packpcx);

/* -------------------------------------------------------------------------- */

