/*
  	popdecl.h

	% Header for popup functions.

	C-scape 3.2
	Copyright (c) 1986, 1987, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 9/01/87 jmd 	added NO_PROTO option
	 7/22/88 jmd 	added pop_Text
	 9/16/88 jmd 	added _arg

	 3/28/90 jmd	ansi-fied
	 8/27/90 jmd	added popparms_struct
	12/05/90 jdc	fixed default auto-sizing
*/

typedef struct _popparms {

	int			shadow;					/* shadow for popups */
	byte		shadowattr;				/* shadow attr for popups */

	int			height;					/* popup default height */
	int			width;					/* popup default width */

} popparms_struct;

extern popparms_struct popparms;

#define	DEFAULT_HEIGHT	-1
#define	DEFAULT_WIDTH	-1

/* PUEDIT.C */
extern void pop_Edit(char *title, char *text, unsigned tlen, int row, int col, int height, int width, byte color, int label, bd_fptr bord);

/* PUMENU.C */
extern int  pop_Menu(char *text, char **choice, int row, int col, int height, int width, byte color, int label, bd_fptr bord);

/* PUMSG.C */
extern void pop_Message(char *msg, int row, int col, int height, int width, byte color, bd_fptr bord);

/* PUPARMS.C */
extern void pop_SetParms(sed_type sed, int row, int col, int height, int width, char *title);

/* PUPROMPT.C */
extern void pop_Prompt(char *msg, int row, int col, int height, int width, byte color, bd_fptr bord);

/* PUTEXT.C */
extern sed_type pop_Text(char *msg, int row, int col, int height, int width, byte color, bd_fptr bord);

/* PUVIEW.C */
extern void pop_View(char *title, char *text, int row, int col, int height, int width, byte color, int label, bd_fptr bord);

