/*
	scancode.h

	% Keyboard scan codes

	OWL 1.2
	Copyright (c) 1986, 1987, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	12/20/88 ted	Extracted pcscan.h so we can conditionally
					include different scancodes for different versions.
	 7/18/89 jmd	changed vmsscan.h to smgscan.h
	 3/03/90 jsm	Added inclusion of QNXSCAN.H
	 5/12/90 jmd	converted to new scheme
	 8/01/90 jmd	added BOB_INC scancode
	 8/24/90 jmd	added PSEUDO_LAST macros
	 9/06/90 jmd	moved PSEUDO macros to here, added KEY_NOTRANS
	10/11/90 ted	added KEY_SIGNAL scancode.
	10/17/90 ted	cast to int in KEY_USER & KEY_PSEUDO.
	10/18/90 jmd	removed OAK_SUN
*/

#ifdef OAK_DOS
#	include "pcscan.h"
#endif

#ifdef OAK_OS2
#	include "pcscan.h"
#endif

#ifdef OAK_UNIX		/*	  	UNIX Dependent Code */
#	include "cursscan.h"
#endif

#ifdef OAK_APOLLO
#	include "gprscan.h"
#endif

#ifdef OAK_VMS		/*	  	VMS Dependent Code */
#	include "vmsscan.h"
#endif

#ifdef OAK_STRATUS		/*	  	STRATUS Dependent Code */
#	include "strtscan.h"
#endif

#ifdef OAK_DG	/*	  	Data General C Dependent Code	*/
#	include "dgscan.h"
#endif

#ifdef OAK_QNX	/* 		QNX dependent code */
#	include "qnxscan.h"
#endif

/* Special codes for users and pseudo scancodes */
#define KEY_USER(n)			((int)(KEY_USERVAL + (n)))
#define KEY_PSEUDO(n)		((int)(KEY_PSEUDOVAL + (n)))

/* macros for oakland application PSEUDO codes */
#define PSEUDO_LAST			22
#define KEY_PSEUDOLAST(n)	KEY_PSEUDO(n + PSEUDO_LAST)

/* standard pseudo-codes */
/* Special code for a scancode non-event */
#define KEY_NONE		KEY_PSEUDO( 0)

/* Special mouse event scancode from hard_ReadEvent() and hard_CheckEvent() */
#define HARD_MEV		KEY_PSEUDO( 1)

/* Special interrupt scancode from hard_ReadEvent() and hard_CheckEvent() */
#define KEY_SIGNAL		KEY_PSEUDO( 2)

/* Used by kb_Read and kb_Check/kb_CheckWait and win_Mouse- functions */
#define MOU_IGNORE		KEY_PSEUDO( 3)
#define MOU_EVENT		KEY_PSEUDO( 4)
#define MOU_CLICK		KEY_PSEUDO( 5)
#define MOU_DCLICK		KEY_PSEUDO( 6)
#define MOU_HOLDDOWN	KEY_PSEUDO( 7)
#define MOU_HERE		KEY_PSEUDO( 8)
#define MOU_THERE		KEY_PSEUDO( 9)
#define MOU_NOFIELD		KEY_PSEUDO(10)
#define MOU_RELEASE		KEY_PSEUDO(11)
								  
/*** bob codes ***/
#define	BOB_QUIT	 	KEY_PSEUDO(12)
#define	BOB_UP	 		KEY_PSEUDO(13)
#define	BOB_DOWN		KEY_PSEUDO(14)
#define	BOB_RIGHT		KEY_PSEUDO(15)
#define	BOB_LEFT		KEY_PSEUDO(16)
#define	BOB_INC			KEY_PSEUDO(17)

/* Special kb_Record key file commands (pseudo-scancodes) */
#define KEY_PAUSE		KEY_PSEUDO(18)
#define KEY_PROMPT		KEY_PSEUDO(19)

#define KEY_INVALID		KEY_PSEUDO(20)

#define KEY_NOTRANS		KEY_PSEUDO(21)

