/*
	sedpriv.h

	% private header for sed objects

	C-scape 3.2
	Copyright (c) 1986-1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	11/28/88 jmd	reorganized headers

	 3/24/89 jmd	added some macros
	 3/29/89 jmd	converted seds to 'pure' objects
	 4/11/89 jmd	added single field paint optimization
	 4/13/89 jmd	put field array into sed_xd as well
	 5/23/89 jdc	made menu_RemoveBob() private (sedpriv.h) not static
	 5/29/89 jmd	simplified paint flags

	12/10/89 jmd 	made ReallyGo a wingo_func
	12/13/89 gam	fixed GetRegAttr, etc. for new xd structure
	 2/15/90 jmd	made GetRegAttr public
	 3/28/90 jmd	ansi-fied
	 7/29/90 jmd	made sed_GetAux call objGetAux
	 9/24/90 jmd 	made ReallyGo a regular func again
*/

/* sed_DoThemBobs Flags */

#define	SDTB_DEP		0x02		/* depend flag */
#define	SDTB_ALL		0x04		/* do all them bobs flag */


/* Function Prototypes */

/* SDOPEN.C */
extern move_func (default_move);

/* SDPLOAT.C */
extern void		sed_Ploat(sed_type sed, ptd_struct *ptd, int blankrow);

/* SDWIN.C */
extern void		menu_RemoveBob(menu_type menu, win_type win);
extern void		sd_plot_field(sed_type sed, field_type field, int fldno, ptd_struct *ptd);

/* SDDOBOB.C */
extern void		sed_DoThemBobs(sed_type sed, int msg, VOID *indata, VOID *outdata, unsigned mode);

/* SDGO.C */
extern int 		sed_ReallyGo(sed_type sed);
extern boolean  sd_exitfield(sed_type sed);

/* SDGOTO.C */
extern void		sd_goto_field(sed_type sed, int fieldno);

/* SDDISP.C */
extern void		sd_adjust_cur(sed_type sed);
extern void		sd_scroll(sed_type sed, int deltarow, int deltacol, boolean preset);
extern boolean  sd_goto_char(sed_type sed, int fieldpos);
extern void		sd_paintbox(sed_type sed, int row, int col, int hgt, int wid, int mode);

/* SDSCRLAD.C */
extern void		sd_scroll_adjust(sed_type sed, int fieldno);

/* SDOVER.C */
extern void		sd_overwrite(sed_type sed);

/* SDOK.C */
extern boolean  sed_Ok(sed_type sed);

/*** paint flag values ***/
/* values >= 0 indicate a single field to be painted */

#define	SDPF_ALL			-1
#define SDPF_NONE			-2
#define	SDPF_FIELDS			-3
#define SDPF_SHADOW			-4

/*** Macros ***/

#define sed_SetFieldNo(sed, fno) 	((sed_getxd(sed))->fieldno = fno)
#define sed_SetCurrField(sed, fld) 	((sed_getxd(sed))->currfield = fld)
#define sed_SetRecordPos(sed, pos) 	((sed_getxd(sed))->fieldpos = pos)

#define sed_SetPaintFlag(sed, f) 	((sed_getxd(sed))->paint_flag = (f))

#define sed_SetXoffset(sed, xoff) 	((sed_getxd(sed))->xoffset = xoff)
#define sed_SetYoffset(sed, yoff) 	((sed_getxd(sed))->yoffset = yoff)

#define sed_SetSelAttr(sed, a)		((sed_getxd(sed))->sel = a)
#define sed_SetRegAttr(sed, a)		((sed_getxd(sed))->reg = a)

#define sed_SetTrow(sed, tr)		((sed_getxd(sed))->row = tr)
#define sed_SetTcol(sed, tc)		((sed_getxd(sed))->col = tc)

#define sed_SetCtype(sed, ct)		((sed_getxd(sed))->ctype = ct)

#define sed_SetMove(sed, m) 		((sed_getxd(sed))->move = m)

#define sed_SetMenu(sed, m) 		((sed_getxd(sed))->menu = m)

#define sed_GetPaintFlag(sed) 		((sed_getxd(sed))->paint_flag)

#define sed_GetExplode(sed)			win_GetExplodeFptr(sed)

#define sed_GetSelAttr(sed)			((sed_getxd(sed))->sel)
#define sed_GetRegAttr(sed)			((sed_getxd(sed))->reg)

#define sed_GetTrow(sed)			((sed_getxd(sed))->row)
#define sed_GetTcol(sed)			((sed_getxd(sed))->col)

#define sed_GetCtype(sed)			((sed_getxd(sed))->ctype)

#define sed_GetMenuVHeight(sed)	menu_GetVHeight(sed_GetMenu(sed))
#define sed_GetMenuVWidth(sed)	menu_GetVWidth(sed_GetMenu(sed))

#define sed_GetSpecial(sed) 	((sed_getxd(sed))->special)
#define sed_GetAux(sed)			obj_GetAux(sed)
#define sed_GetMoveMethod(sed) 	((sed_getxd(sed))->move)
#define sed_GetFuncNameA(sed)	((sed_getxd(sed))->funcnamea)

#define sed_SetMenuVHeight(sed, h)	menu_SetVHeight(sed_GetMenu(sed), h)
#define sed_SetMenuVWidth(sed, w)	menu_SetVWidth(sed_GetMenu(sed), w)

#define sed_SetFieldXoffset(sed, fieldno, x) \
	field_SetXoffset(sed_GetField(sed, fieldno), x)

#define sed_SetFa(sed, flda)	((sed_getxd(sed))->fa = (flda))
#define sed_GetFa(sed)			((sed_getxd(sed))->fa)

#define	sed_IsCache(sed)		((sed_getxd(sed))->cache)
#define	sed_SetCache(sed, x)	((sed_getxd(sed))->cache = (x))

/*** bob macros ***/

#define	sed_GetBobCount(sed)		menu_GetBobCount(sed_GetMenu(sed))

/*** name macros ***/

#define sed_FindFieldNo(sed, name)	\
 	 menu_FindFieldNo(sed_GetMenu(sed), name)

/***  tb stuff ***/
#define sed_RepaintBelow(sed, row) \
	sd_paintbox((sed), row, sed_GetXoffset(sed), \
		sed_GetHeight(sed) - ((row) - sed_GetYoffset(sed)), \
		sed_GetWidth(sed), -1)

#define sed_RepaintRow(sed, row, col, slen) \
	sd_paintbox((sed), row, col, 1, slen, -1)

#define sed_RepaintRows(sed, srow, erow) \
	sd_paintbox((sed), srow, sed_GetXoffset(sed), (erow) - (srow) + 1, sed_GetWidth(sed), -1)
