/*
	sedwinod.h

	% header for sed window object data

	C-scape 3.2
	Copyright (c) 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	11/28/88 jmd	reorganized headers
	12/06/88 jmd	added jumpwin
	12/10/88 jmd	added mousecode

	 2/08/89 jmd	added args
	 3/29/89 jmd	converted seds to 'pure' objects

	 4/11/89 jmd	added closing flag, added blanking flag
	 6/26/89 jmd	removed mousecode

	11/06/89 jmd	removed DoRaw Macro
	 1/04/90 jmd	removed jump window
*/

#include "winod.h"				/* window super class */

/*** sed window object data ***/

typedef struct _sedwinod {
	win_od		wd;		  		/* window super class */

	unsigned 	closing:1;		/* closing flag */
	int			blank;			/* field blanking flag */

} sedwin_od;

#define sedod_GetSelf(sdd)			((sed_type) winod_GetSelf(&(sdd)->wd))

/* -------------------------------------------------------------------------- */
/* Request funcs */

OEXTERN objreq_fptr sdwinreq_mousefptr;
OEXTERN objreq_fptr sdwinreq_loadfptr;
OEXTERN objreq_fptr sdwinreq_savefptr;

/* -------------------------------------------------------------------------- */

