/*
	sfile.h

	% sfile header (public stuff)

	C-scape 3.2
	Copyright (c) 1986-1989 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	---------------------
	 4/21/89 jdc	rewrote for non-global fsymlists
	 4/25/89 jdc	changed fsym macros to sfile macros
	 4/30/89 jmd	renamed AX stuff
	 6/01/89 jdc	changed arg order
	 6/04/89 jdc	renamed file_buf to cs_sfilebuf
	 6/08/89 jmd	split into two headers
	 6/21/89 jmd	added alloc flag to sfile_Load, moved sed_Alloc to seddecl
	 7/22/89 jdc	put file buffer into sfile_struct
	 8/02/89 jdc	added strnewlclip definition
	 8/11/89 jdc	split into sfilewin.h
	 1/21/90 jdc	changed oslist stuff
	 3/28/90 jmd	ansi-fied
	 5/04/90 jdc	added loaddefault_funcs
	 9/07/90 jmd	renamed oslist funcs
*/

#include "winsfile.h"
#include "fsymdecl.h"

/*** flags for sfile_LoadSed ***/

#define	SED_ALLOC	0
#define	SED_NOALLOC	1

/*** function prototypes ***/

/* MENULOAD.C */
extern menu_type sf_loadmenu(sfile_type sfile);
extern int      sfile_PutFieldFunc(sfile_type sfile, char *funcname, field_funcs_ptr funcs, char *typename);

OEXTERN field_funcs_ptr loaddefault_funcs;

/* MENUSAVE.C */
extern boolean  sf_savemenu(sfile_type sfile, menu_type menu);
extern char    *sfile_GetFieldFuncType(sfile_type sfile, int ffhandle);

/* SDLOAD.C */
extern sed_type sfile_LoadSed(sfile_type sfile, char *name, boolean allocate);
extern int      sed_load(sfile_type sfile, sed_type sed);

/* SDSAVE.C */
extern boolean  sfile_SaveSed(sfile_type sfile, sed_type sed, char *name);

/* UFNCSAVE.C */
extern char    *ufunc_FindUserName(bob_type bob, sfile_type sfile);

/*** macros ***/

#define menu_GetFieldFuncType(m, sf, fn)	\
		oslist_GetSym((sf)->oslist_array[FSYM_TY], ia_Get((m)->functypea, fn))

#define menu_PutFieldFuncType(m, sf, ty)	\
		oslist_SetSym((sf)->oslist_array[FSYM_TY], ty, NULL)

#define menu_GetVarName(m, fn)				\
		oslist_GetSym((m)->dptrlist, ia_Get((m)->varnamea, fn))

#define menu_PutVarName(m, vn)				\
		oslist_SetSym((m)->dptrlist, vn, NULL)

#define menu_SetFieldFuncTypeHandle(m, fn, h)	ia_Put((m)->functypea, fn, h)
#define menu_SetVarNameHandle(m, fn, h)			ia_Put((m)->varnamea, fn, h)


