/*
	viadecl.h

	% declarations for Jovian VIA image capture board code

	01/16/89  by Ted.

	OWL-PC 1.2
	Copyright (c) 1988 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 3/28/90 jmd	ansi-fied
*/

/* -------------------------------------------------------------------------- */
typedef struct via_struct {
	unsigned 	seg;
	unsigned 	reg;
	boolean 	mcb;
} *via_type;

/* -------------------------------------------------------------------------- */

/* via abort function type */
#define viabort_func(fname)			boolean fname(void)
typedef viabort_func ((*viabort_fptr));

#define via_close(viainfo)			ofree(OA_VIA, viainfo)

/* PCVGRAB.C */
extern via_type via_Init(void);
extern boolean	via_Grab(via_type viainfo, pmap_type pmap, viabort_fptr abortf);

/* pcvfreez.asm */
extern boolean via_freeze(unsigned addr);
extern boolean via_unfreeze(unsigned addr);
extern boolean via_testretrace(unsigned addr);

extern boolean via_evgacapture(unsigned viaseg, unsigned viareg,
				 byte *pixbuf, int pmnplanes,
				 viabort_fptr abortf, int lines);

extern boolean via_mcgacapture(unsigned viaseg, unsigned viareg,
				 byte *pixbuf, int pmnplanes, viabort_fptr abortf);
/* -------------------------------------------------------------------------- */

