/*
	winod.h

	6/18/88 by Ted.

	% Window object definitions for basic window types

	OWL 1.2
	Copyright (c) 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 8/09/88 jmd	revised to use new object stuff
	11/20/88 jmd	Window tags are now in oakalloc.h (and have new names)

	 8/11/89 jmd	Added new bob class

	11/06/89 jmd	removed DoRaw macros
	11/21/89 ted	Renamed win xd and od bob kernels from cd to bd.
	 3/27/90 ted	Removed cubox win od element.
	 3/28/90 ted	Moved curshide flag to xd.
	 6/18/90 ted	Preened.
*/

#ifndef OAK_WINOD
#define OAK_WINOD

#include "commonod.h"
/* -------------------------------------------------------------------------- */
/* The bob class */

typedef struct _bobod {
	common_od	cd;				/* the common object superclass od */
} bob_od;

#define bobod_GetSelf(bd)			commonod_GetSelf(&(bd)->cd)

/* The window class */

typedef struct _winod {
	bob_od		bd;				/* the bob object superclass od */
	boolean		current;		/* flag for whether this is the current, cursor-showing window */

	pmap_type 	cursunder;		/* graphics mode text cursor under-buffer ptr */
} win_od;

#define winod_GetSelf(wd)			((win_type) bobod_GetSelf(&(wd)->bd))
/* -------------------------------------------------------------------------- */
/* The no_paint window class */

typedef struct _npwinod {
	win_od	wd;		  		/* window super class */
} npwin_od;

#define npwinod_GetSelf(npwd)		(winod_GetSelf(&(npwd)->wd))
/* -------------------------------------------------------------------------- */
/* The blank window class */

typedef struct _blwinod {
	win_od	wd;		  		/* window super class */
} blwin_od;

#define blwinod_GetSelf(blwd)		(winod_GetSelf(&(blwd)->wd))
/* -------------------------------------------------------------------------- */
/* Request funcs */

OEXTERN objreq_fptr winreq_loadfptr;
OEXTERN objreq_fptr winreq_savefptr;

#endif

