/*
	lnfmenu.h

	%	LNF SCAN_ and COM_ values

	Look & Feel 3.2
	Copyright (c) 1990, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 8/24/90 jdc	switched to lnfmenu.h scheme
	 8/31/90 jdc	improved the COM_ scheme
	 9/02/90 jdc	added macros
	 9/11/90 jdc	added COM_SEARCHAGAIN
*/

/*	The following SCAN_ values are quickkeys for operating LNF functions.
	They can be redefined as desired.

	The LNF menubar returns COM_ values which are indexes into a scancode
	array the results of which is handled like any keystoke.
	Translating COM_ into SCAN_ values allows the same screen file menubar
	image to work on platforms with differing keyboard scancode values.

	The menubar's fields (which usually contain the keystroke name) can
	be changed by loading, editing, and resaving the "menu" screen from 
	lnf.oak.
*/

/* keyboard only scans
*/
#define SCAN_NEXTWORD				CTRL_RIGHT
#define SCAN_PREVWORD				CTRL_LEFT
#define SCAN_MAXIMIZE				CTRL_FN1
#define SCAN_MINIMIZE				CTRL_FN2
#define SCAN_ALLGO					CTRL_FN9
#define SCAN_DEMOPROMPT				CTRL_FN10		
#define SCAN_SLIDEFLD				FN5
#define	SCAN_MENU					FN10
#define	SCAN_GOTO					CTRL_G
#define	SCAN_TOGGLEINS				CTRL_I
#define SCAN_REFRESH				CTRL_Z
#define SCAN_MACRO					CTRL_D

/* menubar also scans (in menubar order)
*/
#define SCAN_LOADSCR				CTRL_J
#define SCAN_SAVE					CTRL_S
#define SCAN_IMPORT					KEY_USER(1)
#define SCAN_GENCODE				KEY_USER(2)
#define SCAN_GENSYMS				KEY_USER(3)
#define SCAN_ABOUT					KEY_USER(4)

#define SCAN_OPENSCR				CTRL_O
#define SCAN_EDITSCR				FN2
#define SCAN_DELSCR					CTRL_Y
#define SCAN_NEXTSCR				CTRL_N
#define SCAN_LISTSCR				FN3
#define SCAN_SIMULATE				FN9
#define SCAN_MOVE					CTRL_M
#define SCAN_RESIZE					CTRL_R
#define SCAN_WIPESCR				KEY_USER(5)

#define SCAN_EDITFLD				CTRL_E
#define SCAN_MARKFLD				CTRL_F
#define SCAN_LISTFLD				FN4
#define SCAN_GLOBFLD				KEY_USER(6)
#define SCAN_ROWSORT				KEY_USER(7)
#define SCAN_COLSORT				KEY_USER(8)

#define SCAN_CUTBLOCK				CTRL_X
#define SCAN_COPYBLOCK				CTRL_K
#define SCAN_MOVEBLOCK				CTRL_T
#define SCAN_DELBLOCK				KEY_USER(9)
#define SCAN_ATTRBLOCK				CTRL_A
#define SCAN_PASTE					CTRL_P

#define SCAN_EDITOPEN				FN6
#define SCAN_SEARCH					FN7
#define SCAN_SEARCHAGAIN			CTRL_FN7
#define SCAN_REPLACE				FN8

#define SCAN_ATTACHBOB				CTRL_W
#define SCAN_DETACHBOB				KEY_USER(10)
#define SCAN_EMBEDBOB				CTRL_B
#define SCAN_USERBOB				CTRL_U

#define SCAN_LINE					CTRL_L
#define SCAN_SPECCHAR				CTRL_C
#define SCAN_GLOBALSET				KEY_USER(11)
#define SCAN_GOTOTOP				CTRL_HOME
#define SCAN_GOTOBOT				CTRL_END

#define SCAN_HELP					FN1
#define SCAN_KEYHELP				CTRL_H

#define SCAN_QUIT					CTRL_Q

/* menubar com values
*/
#define COM_LOADSCR					1
#define COM_SAVE					2
#define COM_IMPORT					3
#define COM_GENCODE					4
#define COM_GENSYMS					5
#define COM_ABOUT					6

#define COM_OPENSCR					10
#define COM_EDITSCR					11
#define COM_DELSCR					12
#define COM_NEXTSCR					13
#define COM_LISTSCR					14
#define COM_SIMULATE				15
#define COM_MOVE					16
#define COM_RESIZE					17
#define COM_WIPESCR					18

#define COM_EDITFLD					20
#define COM_MARKFLD					21
#define COM_LISTFLD					22
#define COM_GLOBFLD					23
#define COM_ROWSORT					24
#define COM_COLSORT					25

#define COM_CUTBLOCK				31
#define COM_COPYBLOCK				32
#define COM_MOVEBLOCK				33
#define COM_DELBLOCK				34
#define COM_ATTRBLOCK				35
#define COM_PASTE					36

#define COM_EDITOPEN				40
#define COM_SEARCH					41
#define COM_REPLACE					42
#define COM_SEARCHAGAIN				43

#define COM_ATTACHBOB				50
#define COM_DETACHBOB				51
#define COM_EMBEDBOB				52
#define COM_USERBOB					53

#define COM_LINE					60
#define COM_SPECCHAR				61
#define COM_GLOBALSET				62
#define COM_GOTOTOP					63
#define COM_GOTOBOT					64

#define COM_HELP					70
#define COM_KEYHELP					71

#define COM_QUIT					80

#define COM_LAST					90

