/*
	fsymidef.c

	%	the default Function Symbol Initialization List

	This file contains the default initialization list used by sfiles.
	These structures map symbolic names to function pointers.
	To support more (or remove) functions simply add (or delete)
	the name and function in the list.

	C-scape 3.2
	Copyright (c) 1989 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 8/04/89 gam	changed #include <sledwin.h> to sled.h

	 2/15/90 jmd	added radio_funcs
	 3/28/90 jmd	ansi-fied
	 4/12/90 jmd 	added aux_Top
	 5/10/90 jdc	added FSYM_GOFUNC
	 9/21/90 pmcm	made def_fsyminit_list OGLOBAL
	 9/24/90 jdc	removed gofunc code
*/

#include "sed.h"
#include "fsymdecl.h"
#include "fndecl.h"
#include "msys.h"
#include "teddecl.h"
#include "sled.h"
#include "explode.h"
#include "ufuncod.h"

OGLOBAL fsyminit_struct def_fsyminit_list[] = {

{FSYM_CLASS},
{"win_Class",		(VOID_FPTR)	win_Class		,  NULL },
{"sedwin_Class",	(VOID_FPTR)	sedwin_Class	,  NULL },
{"sledwin_Class",	(VOID_FPTR)	sledwin_Class	,  NULL },
{"ufunc_Class",		(VOID_FPTR)	ufunc_Class		,  NULL },

{FSYM_FIELDFUNCS},
{"alpha_funcs",		FNULL, (VOID *)	&alpha_funcs	},
{"bob_funcs",		FNULL, (VOID *)	&bob_funcs		},
{"char_funcs",		FNULL, (VOID *)	&char_funcs		},
{"check_funcs",		FNULL, (VOID *)	&check_funcs	},
{"clong_funcs",		FNULL, (VOID *)	&clong_funcs	},
{"cmoney_funcs",	FNULL, (VOID *)	&cmoney_funcs	},
{"date_funcs",		FNULL, (VOID *)	&date_funcs		},
{"digit_funcs",		FNULL, (VOID *)	&digit_funcs	},
{"double_funcs",	FNULL, (VOID *)	&double_funcs	},
{"framer_funcs",	FNULL, (VOID *)	&framer_funcs	},
{"gmenu_funcs",		FNULL, (VOID *)	&gmenu_funcs	},
{"hex_funcs",		FNULL, (VOID *)	&hex_funcs 		},
{"int_funcs",		FNULL, (VOID *)	&int_funcs 		},
{"list_funcs",		FNULL, (VOID *)	&list_funcs		},
{"long_funcs",		FNULL, (VOID *)	&long_funcs		},
{"menu_funcs",		FNULL, (VOID *)	&menu_funcs		},
{"money_funcs",		FNULL, (VOID *)	&money_funcs	},
{"pint_funcs",		FNULL, (VOID *)	&pint_funcs		},
{"plong_funcs",		FNULL, (VOID *)	&plong_funcs	},
{"radio_funcs",		FNULL, (VOID *)	&radio_funcs	},
{"range_funcs",		FNULL, (VOID *)	&range_funcs	},
{"secure_funcs",	FNULL, (VOID *)	&secure_funcs	},
{"select_funcs",	FNULL, (VOID *)	&select_funcs	},
{"sfloat_funcs",	FNULL, (VOID *)	&sfloat_funcs	},
{"sint_funcs",		FNULL, (VOID *)	&sint_funcs		},
{"slong_funcs",		FNULL, (VOID *)	&slong_funcs	},
{"slug_funcs",		FNULL, (VOID *)	&slug_funcs		},
{"string_funcs",	FNULL, (VOID *)	&string_funcs	},
{"ted_funcs",		FNULL, (VOID *)	&ted_funcs		},
{"time_funcs",		FNULL, (VOID *)	&time_funcs		},
{"toggle_funcs",	FNULL, (VOID *)	&toggle_funcs	},
{"yesno_funcs",		FNULL, (VOID *)	&yesno_funcs	},
{"xstring_funcs",	FNULL, (VOID *)	&xstring_funcs	},

{FSYM_MOVEMETHOD},
{"ted_Follow",		(VOID_FPTR)	ted_Follow		,  NULL },
{"ted_Past",		(VOID_FPTR)	ted_Past		,  NULL },

{FSYM_EXPLODE },
{"exp_std",			(VOID_FPTR)	exp_std			,  NULL },
{"exp_BeamMeUp",	(VOID_FPTR)	exp_BeamMeUp	,  NULL },

{FSYM_SPECIAL},
{"spc_Embed", 		(VOID_FPTR)	spc_Embed		,  NULL },
{"spc_EbedTed",		(VOID_FPTR)	spc_EmbedTed	,  NULL },
{"spc_Abort",		(VOID_FPTR)	spc_Abort		,  NULL },
{"spc_Sled",		(VOID_FPTR)	spc_Sled		,  NULL },

{FSYM_BORDER},
{"bd_mouse",		(VOID_FPTR)	bd_mouse		,  NULL },
{"bd_prompt",		(VOID_FPTR)	bd_prompt		,  NULL },
{"bd_bar",			(VOID_FPTR)	bd_bar			,  NULL },
{"bd_box", 			(VOID_FPTR)	bd_box			,  NULL },
{"bd_boxlight",		(VOID_FPTR)	bd_boxlight		,  NULL },
{"bd_plain",		(VOID_FPTR)	bd_plain		,  NULL },
{"bd_title",		(VOID_FPTR)	bd_title		,  NULL },
{"bd_std",			(VOID_FPTR)	bd_std			,  NULL },
{"bd_null",			(VOID_FPTR)	bd_null			,  NULL },
{"bd_1",   			(VOID_FPTR)	bd_1			,  NULL },
{"bd_2",   			(VOID_FPTR)	bd_2			,  NULL },
{"bd_123", 			(VOID_FPTR)	bd_123			,  NULL },
{"bd_xref",			(VOID_FPTR)	bd_xref			,  NULL },

{FSYM_MOUSE},
{"sedmou_Click",	(VOID_FPTR)	sedmou_Click	,  NULL },
{"sedmou_Track",	(VOID_FPTR)	sedmou_Track	,  NULL },
{"sedmou_GreedyClick",(VOID_FPTR)	sedmou_GreedyClick ,  NULL },
{"sedmou_GreedyTrack",(VOID_FPTR)	sedmou_GreedyTrack ,  NULL },
{"sedmou_Framer",	(VOID_FPTR)	sedmou_Framer	,  NULL },

{FSYM_AUX},
{"aux_Top", 		(VOID_FPTR)	aux_Top			,  NULL },

{FSYM_USER},
{FSYM_FONT},

{FSYM_LISTEND}
};

