/*
	helpshow.c

	% help_Show

	The help_Show routine.

	C-scape 3.2
	Copyright (c) 1986, 1987, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 9/16/88 jmd 	added help_fptr
	12/13/88 jmd 	added hshow_fptr
	 3/28/90 jmd	ansi-fied
*/

#include <stdio.h>
#include "cscape.h"
#include "helpdecl.h"

static hshow_fptr	helpshow = FNULL;

int help_Show(int chap, int par)
/*
	Searches for the appropriate message.
	Displays the message via the display function.

	If no there is no message for the paragraph, try and give
	the message for the chapter.  If unable to display a message
	return(0) else return(1).
*/
/*
	Note:	This is actually just a shell that call the real
			help_Show function indirectly.  This implementation
			keeps the help code from being linked in when it is
			not used while still allowing the standard field functions
			to call help_Show().
*/
{
	if (helpshow == FNULL) {
		return(0);
	}

	return((*helpshow)(chap ,par));
}

void _help_InitShow(hshow_fptr func)
/*
	Initializes the help_Show function.
*/
{
	helpshow = func;
}
