/*
	sdgetcor.c		3/24/87

	% sed_GetCorners

	C-scape 3.2
	Copyright (c) 1986, 1987, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 7/07/88 jmd	added windows
	11/14/88 jmd	added newest border scheme

	 2/07/89 jmd	Removed bordobj.h
	 3/31/89 jmd	seds are now windows

	 3/28/90 jmd	ansi-fied
*/

#include "sed.h"

void sed_GetCorners(sed_type sed, int *ul_row, int *ul_col, int *lr_row, int *lr_col)
/* 
	Gets the upper left and lower right hand corners of the sed
	and places them into (ul_row, ul_col) and (lr_row, lr_col). 
	
	The corners are given in screen coordinates.
	This function ignores borders.
*/
{
	*ul_row = win_GetTopRow(sed);
	*ul_col = win_GetLeftCol(sed);
	*lr_row = win_GetBotRow(sed);
	*lr_col = win_GetRightCol(sed);
}

void sed_GetBordCorners(sed_type sed, int *ul_row, int *ul_col, int *lr_row, int *lr_col)
/* 
	Gets the upper left and lower right hand corners of the sed
	and places them into (ul_row, ul_col) and (lr_row, lr_col). 
	If there is a border then the corners of the border are returned,
	provided that they are outside the sed.
*/
{
	*ul_row = bord_GetTopRow(sed);
	*ul_col = bord_GetLeftCol(sed);
	*lr_row = bord_GetBotRow(sed);
	*lr_col = bord_GetRightCol(sed);
}
