/*
	sdpushlt.c

	% sed_PushLeft

	C-scape 3.2
	Copyright (c) 1986, 1987, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	11/06/86 jmd	Now returns the edge character.  This will have to be 
					changed when "string too short" is fixed. 
	11/16/86 sng	Now handles variable-length fields.
	11/18/87 jmd 	changed names of some low-level funcs
	 5/11/88 jmd 	moved work to field_PushLeft

	 3/24/89 jmd	added sed_ macros

	 3/28/90 jmd	ansi-fied
*/

#include "sed.h"
#include "fldpriv.h"

char sed_PushLeft(sed_type sed, int scancode)
/*
	modifies:   the sed.
	effects:    inserts the scancode at the current position, pushes the
	   			characters to the left:
				|x  hell mom|
					   ^
				|  hello mom|	  ---> return('x');
					   ^ 
	returns:	the character that falls off the edge.  If nothing falls off
 				the edge, return '\0'.
*/
{
	char edge_char;

	cs_Assert(sed_Ok(sed), CS_SD_PSHL_SED, 0);

	edge_char = menu_PushLeft(sed_GetMenu(sed), sed_GetFieldNo(sed), sed_GetRecordPos(sed), (char) scancode);
	sd_refresh_field(sed, sed_GetFieldNo(sed));

	return(edge_char);
}

