/*
	sdsethgt.c		3/14/87

	% sed_SetHeight

	C-scape 3.2
	Copyright (c) 1986, 1987, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 6/30/88 jmd	added windows
	 7/08/88 jmd	removed ymin
	12/10/88 jmd	added sed_DoThemBobs
	12/20/88 jmd	removed bord_SendMsg

	 8/08/89 jmd	removed bob stuff (handled by window now)

	 3/28/90 jmd	ansi-fied
*/

#include "sed.h"

void sed_SetHeight(sed_type sed, int height)
/* 
	Sets the height of the sed.
	The height is adjusted vs. the sed's position
	so as to not allow the sed to go past the edge of the screen.
	If there is a border, the border is sent a BDM_SETSIZE message
	and it's height is compensated for.
	The height can never be less than 1.
*/
{
	cs_Assert(sed_Ok(sed), CS_SD_SHGT_SED, 0);
	cs_Assert(height > 0, CS_SD_SHGT_NEG, 0);
	
	/* adjust window */
	win_SetSize(sed, height, win_GetWidth(sed));
}			

