/*
	bdplain.c	1/22/87

	% plain border routine.

	OWL 1.2
	Copyright (c) 1986, 1987, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	11/22/87 jmd 	Replaced line characters with octal escape sequences
	 8/15/88 jmd 	Upgraded to new border stuff
	 9/12/88 jmd	Added in and out data
	11/13/88 jmd	Upgraded to new border stuff
	11/20/88 jmd	Added ID to obj struct
	12/20/88 jmd	removed SETSIZE msg

	 4/21/89 jmd	added object data
	 5/28/89 jmd	added Shadow support

	11/06/89 jmd	removed DoRaw macros
	 2/21/90 ted	Added SetCharSize(TRUE) because border won't work otherwise.
	 3/28/90 jmd	ansi-fied
*/

#include "oakhead.h"
#include "disppriv.h"
#include "bordobj.h"
#include "bordod.h"

#define OUTER_BOX	 "\332\304\267\272\274\315\324\263"

/* border object data */

typedef struct _bdplainod {
	border_od	bdd;		  				/* border object super class */
} bdplain_od;

int bd_plain(VOID *objdata, int msg, VOID *indata, VOID *outdata)
/*
	This is a simple single lined border.
*/
{
	bdplain_od *bdpd;
	ocbox	    cbox;
	byte		 attr;

	bdpd = (bdplain_od *)objdata;

	switch(msg) {
	case OBJM_GETDATASIZE:
		((ogds_struct *) outdata)->odsize = sizeof(bdplain_od);
		((ogds_struct *) outdata)->xdsize = sizeof(border_xd);
		((ogds_struct *) outdata)->id = ID_BDPLAIN;
		break;

	case OBJM_OPEN:
		if (!border_Class(&bdpd->bdd, msg, indata, outdata)) {
			return(FALSE);
		}
		win_SetCharSize(bdpd->bdd.win, TRUE);	/* This bord must be charsize */
		bord_SetSides(bdpd->bdd.win, -1, -1, 1, 1);
		break;

	case BDM_SHADOW:
	case BDM_DRAW:
		bord_GetBox(bdpd->bdd.win, &cbox);
		attr = (msg == BDM_DRAW) ? 
			bord_GetAttr(bdpd->bdd.win) : win_GetShadowAttr(bdpd->bdd.win);

		ptd_DrawCharBox((ptd_struct *)indata, OUTER_BOX, &cbox, attr);

		/* else no break; pass message up to superclass */

	default:
		/* pass messages up to border super class */
		return(border_Class(&bdpd->bdd, msg, indata, outdata));
	}

	return(TRUE);
}

