/*
	bobgtown.c		

	% bob_GetOwner

	OWL 1.2
	Copyright (c) 1989, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 8/08/89 jmd 	made a separate file
	 8/21/89 jmd 	fixed GP fault bug

	12/20/89 jmd	removed assumption that owner is a sed, moved to OWL
	 3/28/90 jmd	ansi-fied
*/

#include "oakhead.h"
#include "disppriv.h"
/* -------------------------------------------------------------------------- */

win_type bob_GetOwner(bob_type bob, int *childnop)
/*
	Returns the window to which the bob is attached.
	Places the child (field) number to which the bob is attached in 
	childnop, returns NULL if the bob is not attached to anything.
*/
{
	win_type win = NULL;

	/* Get the parent win */
	if (bob != NULL && ((win = bob_GetParent(bob)) != NULL)) {
		win_Do(win, WINM_GETCHILDNO, bob, childnop);
	}
	return(win);
}
/* -------------------------------------------------------------------------- */

