/*
	bobset.c

	% bob_SetPosition, bob_GetPosition

	No one uses these things but they're in the manual
	so....

	OWL 1.2
	Copyright (c) 1989, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 3/28/90 jmd	ansi-fied
*/

#include "oakhead.h"
#include "disppriv.h"
#include "bordobj.h"

void bob_GetPosition(bob_type bob, int *rowp, int *colp)
/*
	Get the position of a bob.
*/
{
	if (bob_IsWin(bob)) {
		*rowp = bord_GetTopRow(bob);
		*colp = bord_GetLeftCol(bob);
	}
	else {
		*rowp = 0;
		*colp = 0;
	}
}

void bob_GetSize(bob_type bob, int *heightp, int *widthp)
/*
	Get the height and width of a bob.
*/
{
	if (bob_IsWin(bob)) {
		*heightp = bord_GetHeight(bob);
		*widthp = bord_GetWidth(bob);
	}
	else {
		*heightp = 0;
		*widthp = 0;
	}
}
