/*
	bordaux.c

	% auxillary	routines for borders.

	OWL 1.2
	Copyright (c) 1986, 1987, 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	12/16/88 jmd	pulled out of border.c
	12/18/88 jmd	removed bord_SendMsg

	 1/20/89 jmd	fixed bug in bord_GetPixBox
	 5/28/89 jmd	added Shadow support
	 8/12/89 ted	changed Shadow support

	 1/17/90 ted	Added shademsg args to _Expose functions.
	 3/28/90 jmd	ansi-fied
*/

#include "oakhead.h"
#include "disppriv.h"
#include "bordobj.h"

/* -------------------------------------------------------------------------- */

void bord_GetPixBox(win_type win, opbox *boxp)
{
	boxp->xmin = 0;
	boxp->ymin = 0;
	boxp->xmax = bord_GetPixWidth(win);
	boxp->ymax = bord_GetPixHeight(win);

	opbox_trans(boxp, bord_xoffs(win), bord_yoffs(win));
}
/* -------------------------------------------------------------------------- */

void bord_GetBox(win_type win, ocbox *cboxp)
{
	opcoord fw, fh;

	fw = win_GetFontWidth(win);
	fh = win_GetFontHeight(win);

	cboxp->toprow   = 0;
	cboxp->leftcol  = 0;
	cboxp->botrow   = bord_GetHeight(win) - 1;
	cboxp->rightcol = bord_GetWidth(win) - 1;

	ocbox_trans(cboxp, bord_yoffs(win)/fh, bord_xoffs(win)/fw);
}
/* -------------------------------------------------------------------------- */

void bord_Expose(win_type win, int emsg, VOID *emsgdata, int shademsg, VOID *shademsgdata)
/*
	Expose the whole window which the border is attached to, including the
	border frame and shadow.
*/
{
	opbox shbox;

	if (win != NULL) {
		win_getshadowbox(win, &shbox);
		wmgr_ExposePixBox(win, NULL, &shbox, emsg, emsgdata, shademsg, shademsgdata);
	}
}
/* -------------------------------------------------------------------------- */

