/*
	bordsetp.c

	% bord_SetPixPosition

	OWL 1.2
	Copyright (c) 1989, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 3/28/90 jmd	ansi-fied
*/

#include "oakhead.h"
#include "disppriv.h"
#include "bordobj.h"

/* -------------------------------------------------------------------------- */

void bord_SetPosition(win_type win, int row, int col)
/*
	Change the position of window.
	Moves the window so that the corner of its border is at row, col
*/
{
	bord_SetPixPosition(win, 
		col * win_GetFontWidth(win), row * win_GetFontHeight(win));
}
/* -------------------------------------------------------------------------- */

void bord_SetPixPosition(win_type win, opcoord xpos, opcoord ypos)
/*
	Change the position of window.
	Moves the window so that the corner of its border is at xpos, ypos
*/
{
	xpos -= bord_xoffs(win);
	ypos -= bord_yoffs(win);

	win_SetPixPosition(win, xpos, ypos);
}
/* -------------------------------------------------------------------------- */

