/*
	bordssds.c

	% bord_SetSides

	2/87 by jmd

	OWL 1.2
	Copyright (c) 1987, 1988, 1989 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	10/31/88 Ted	Removed linking.
	 5/28/89 jmd	added Shadow support
	 8/10/89 ted	Moved Shadow support to winexpos.
	 9/27/89 ted	Added bord_GetSides funcs.

	12/02/89 ted	Made bord_GetSides a macro to bord_getfwhsides.
	12/10/89 jmd	made win_GetBorder macro
	 3/28/90 jmd	ansi-fied
*/

#include "oakhead.h"
#include "disppriv.h"
#include "bordobj.h"
/* -------------------------------------------------------------------------- */

void bord_SetSides(win_type win, int topoffs, int leftoffs, int botoffs, int rightoffs)
/*
	Sets the relative sides of the border.
	Should be called when border is opened and when
	a SETSIZE message is received.
*/
{
	opcoord fw, fh;

	fw = win_GetFontWidth(win);
	fh = win_GetFontHeight(win);

	bord_SetPixSides(win, (opcoord) leftoffs*fw, (opcoord) topoffs*fh,
						  (opcoord) rightoffs*fw, (opcoord) botoffs*fh);
}
/* -------------------------------------------------------------------------- */

void bord_SetPixSides(win_type win, opcoord xminoffs, opcoord yminoffs, opcoord xmaxoffs, opcoord ymaxoffs)
/*
	Sets the relative sides of the border.
	Should be called when border is opened and when SETSIZE message is received.
*/
{
	opcoord winx, winy, winw, winh;

	winx = win_GetXmin(win);
	winy = win_GetYmin(win);

	winw = win_GetPixWidth(win);
	winh = win_GetPixHeight(win);

	win_inboxp(win)->xmin = -xminoffs;
	win_inboxp(win)->ymin = -yminoffs;

	win_ReallySetPixPosition(win, winx, winy);

	win_inboxp(win)->xmax = opbox_GetWidth(win_pixboxp(win)) - xmaxoffs;
	win_inboxp(win)->ymax = opbox_GetHeight(win_pixboxp(win)) - ymaxoffs;

	win_ReallySetPixSize(win, winw, winh);
}
/* -------------------------------------------------------------------------- */

boolean bord_getfwhsides(win_type win, opcoord fw, opcoord fh, int *topoffsp, int *leftoffsp, int *botoffsp, int *rightoffsp)
{
	opcoord xminoffs, yminoffs, xmaxoffs, ymaxoffs;

	if (bord_GetPixSides(win, &xminoffs, &yminoffs, &xmaxoffs, &ymaxoffs)) {

		*topoffsp	= -((-yminoffs) / fh);
		*botoffsp	= ymaxoffs / fh;
		*leftoffsp	= -((-xminoffs) / fw);
		*rightoffsp	= xmaxoffs / fw;

		return(TRUE);
	}
	else return(FALSE);
}
/* -------------------------------------------------------------------------- */

boolean bord_GetPixSides(win_type win, opcoord *xminoffsp, opcoord *yminoffsp, opcoord *xmaxoffsp, opcoord *ymaxoffsp)
{
	*xminoffsp = -win_inboxp(win)->xmin;
	*yminoffsp = -win_inboxp(win)->ymin;

	*xmaxoffsp = opbox_GetWidth(win_pixboxp(win)) - win_inboxp(win)->xmax;
	*ymaxoffsp = opbox_GetHeight(win_pixboxp(win)) - win_inboxp(win)->ymax;

	return(win_GetBorder(win) != NULL);
}
/* -------------------------------------------------------------------------- */

