/*
	digcursb.c

	% Function for getting graphics cursor box given cursor type.

	5/16/88  by Ted.
	Extracted from pcfuncs.c

	OWL-DIG 1.2
	Copyright (c) 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 3/28/90 jmd	ansi-fied
*/

#include "oakhead.h"
#include "disppriv.h"
#include "digutil.h"

/* -------------------------------------------------------------------------- */

void DIGPRIV dig_getcursbox(win_type win, cursortype ctype, opbox *cursboxp)
{
	opcoord start, end;

	dig_getcurslines(ctype, win_GetFontHeight(win), &start, &end);
	cursboxp->xmin = win_GetCursx(win);
	cursboxp->xmax = cursboxp->xmin + (win_GetFontWidth(win) * 7 / 8);
	cursboxp->ymin = win_GetCursy(win) - win_GetFontHeight(win);
	cursboxp->ymax = cursboxp->ymin + end;
	cursboxp->ymin += start;
}
/* -------------------------------------------------------------------------- */

