/*
	digflip.c

	% Functions for flipping bytes in loaded words to match machine byte order.

	5/02/88  by Ted.

	OWL-DIG 1.2
	Copyright (c) 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 3/28/90 jmd	ansi-fied
	 6/22/90 ted	added "void"s to no-parameter function per ansii.
*/

#include "oakhead.h"
#include "disppriv.h"
#include "digutil.h"

typedef struct { byte lo, hi; } split;

/* -------------------------------------------------------------------------- */

void dig_flipshort(unsigned short *usp)
{
	byte tmp;

	tmp = ((split *) usp)->lo;
	((split *) usp)->lo = ((split *) usp)->hi;
	((split *) usp)->hi = tmp;
}
/* -------------------------------------------------------------------------- */

byte DIGPRIV dig_testbyteorder(void)
/*
	Determines which kind of byte order the current processor uses.
*/
{
	unsigned short test;
	byte low;

	test = 1;
	low = ((split *)(&test))->lo;
	return((low == 1) ? BO_LSBYTFIRST : BO_MSBYTFIRST);
}
/* -------------------------------------------------------------------------- */

