/*
	disprein.c

	% Display manager change-horses-in-midstream swapper.

	8/12/89  by Ted.

	OWL 1.2
	Copyright (c) 1988, 1989 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 3/28/90 jmd	ansi-fied
	 3/29/90 ted	Added win_Hide/ShowCursor to make cursor show afer reinit.
*/
#include "oakhead.h"
#include "disppriv.h"

/* -------------------------------------------------------------------------- */

boolean disp_ReInit(dmode_fptr dmode)
/*
	Change display manager without changing windows or window manager.
*/
{
	boolean mouseon;
	boolean curson;

	mouseon = hard_IsMouseOn();
	if (mouseon) hard_DeinitMouse();

	curson = win_HideCursor(disp_GetCurrentWin());

	/* Close fonts for all windows */

	/* Go back to initial mode so that new dmgr will have correct 'oldmode' */
	disp_RestoreMode();

	/* Close down current DIG */
	disp_CloseDIG();

	/* Initialize a new display manager and DIG. */
	if (!dispsetup(dmode)) {
		return(FALSE);
	}

	/* Restore fonts for all windows */

	win_SetPixSize(disp_GetDispWin(), disp_GetPixWidth(), disp_GetPixHeight());

	disp_Repaint();

	if (curson)  win_ShowCursor(disp_GetCurrentWin());
	if (mouseon) hard_InitMouse();

	return(TRUE);
}
/* -------------------------------------------------------------------------- */

