/*
	expstd.c

	% Explode function for windows

	OWL 1.2
	Copyright (c) 1988, 1989 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 8/17/88 jmd	created
	 9/12/88 jmd	Added in and out data to objects
	12/01/88 jmd	Tinkered with delay, steps, etc.

	 8/13/89 jmd	removed GETEXPLODE message
	 3/28/90 jmd	ansi-fied
*/


#include "oakhead.h"
#include "disppriv.h"

#include "explode.h"

#define EXPLODE_BOX	 "\332\304\277\263\331\304\300\263"
#define ERASE_BOX	 "        "

int exp_std(VOID *objdata, int msg, VOID *indata, VOID *outdata)
/*
	"Standard" explode function.
*/
{
	ptd_struct *ptd;
	int 			  explode, hgt, wid;
	ocbox			  cbox;
	byte 			  attr;

	/* objdata is ignored. */ oak_notused(objdata);
	/* outdata is not used. */ oak_notused(outdata);

	switch (msg) {
	case WINM_EXPLODE:
		/* paint an explode window (called with increasing values of explode) */
		ptd = (ptd_struct *)indata;

		for (explode = 3; explode < 6; explode++) {
			hgt = win_GetHeight(ptd->win);
			wid = win_GetWidth(ptd->win);
			attr = win_GetAttr(ptd->win);

			cbox.toprow   = hgt/explode;
			cbox.leftcol  = wid/explode;
			cbox.botrow   = hgt - cbox.toprow;
			cbox.rightcol = wid - cbox.leftcol;

			ptd_DrawCharBox(ptd, EXPLODE_BOX, &cbox, attr);
			hard_Pause(1);
			ptd_DrawCharBox(ptd, ERASE_BOX, &cbox, attr);
		}
		break;
	}

	return(TRUE);
}
/* -------------------------------------------------------------------------- */

