/*
  	oakerror.c 

	% oak_Error: The Oakland C-tools error handler.

	OWL 1.2
	Copyright (c) 1986, 1987, 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	12/13/88 jmd	removed printf
	 3/28/90 jmd	ansi-fied
*/

#include "oakhead.h"
#include "disppriv.h"
/* -------------------------------------------------------------------------- */

void oak_Error(int prod, int err, int num)
/*
	Display error and exit.
	prod is the Oakland product code.
	If prod == C_SCAPE && num != 0 then show menu_Printf line number.
*/
{
	char errmsg[100];

	disp_Close();

	switch (prod) {
	case C_OWL:
		sprintf(errmsg, "Oakland windowing layer: Error Number %d.", err);
		break;

	case C_SCAPE:
		if (num == 0) {
			sprintf(errmsg, "C-scape: Error Number %d.", err);
		}
		else {
			sprintf(errmsg, "C-scape: Error Number %d in menu_Printf() %d.", err, num);
		}
		break;

	case C_CELL:
		sprintf(errmsg, "C-cell: Error Number %d.", err);
		break;

	default:
		sprintf(errmsg, "oak_Error: Unknown Error Number %d.", err);
		break;
	}

	puts(errmsg);
	exit(0);
}
/* -------------------------------------------------------------------------- */

