/*
	pcmcurr.c

	% pc_ModeCurrent, pc_OpenMode

	5/16/88  by Ted.

	OWL-PC 1.2
	Copyright (c) 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 3/23/89 ted	renamed from pcdefdsp.c
	 3/28/90 jmd	ansi-fied
*/

#include "pcpriv.h"

/* -------------------------------------------------------------------------- */

boolean pc_ModeCurrent(dig_struct *digp)
{
	int mode;

	/* Get Current Mode from hardware */
	mode = pc_GetMode();

	/* Call to open with current mode */
	return(pc_OpenMode(digp, mode));
}
/* -------------------------------------------------------------------------- */

boolean DIGPRIV pc_OpenMode(dig_struct *digp, int mode)
/*
	Open a pc display in the given mode, if possible.
*/
{
	switch(mode) {
	case 0x00:
	case 0x01:
	case 0x02:
	case 0x03:
	case PCMODE_EGA43:
	case PCMODE_VGA50:
		return(pc_OpenText(digp, mode));
	case 0x07:
		return(pc_OpenText(digp, mode));

	case PCMODE_HERC0:
	case PCMODE_HERC1:
		return(pc_OpenHerc(digp, mode));
	case 0x04:
	case 0x05:
	case 0x06:
	case 0x40:
	case PCMODE_CPQ40:
		return(pc_OpenCGA(digp, mode));
	case 0x0D:
	case 0x0E:
	case 0x0F:
	case 0x10:
	case 0x11:
	case 0x12:
		return(pc_OpenEVGA(digp, mode));
	case 0x13:
		return(pc_OpenMCGA(digp, mode));
	default:
		return(FALSE);
	}
}
/* -------------------------------------------------------------------------- */

