/*
	pcmcurrt.c

	% pc_ModeCurrText, pc_OpenModeText

	 4/10/88  by Ted.
	Created so you can have current text mode capability w/o linking in all
	the pc graphics code.

	OWL-PC 1.2
	Copyright (c) 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 3/28/90 jmd	ansi-fied
*/

#include "pcpriv.h"

/* -------------------------------------------------------------------------- */

boolean pc_ModeCurrText(dig_struct *digp)
{
	int mode;

	/* Get Current Mode from hardware */
	mode = pc_GetMode();

	/* Call to open with current mode */
	return(pc_OpenModeText(digp, mode));
}
/* -------------------------------------------------------------------------- */

boolean DIGPRIV pc_OpenModeText(dig_struct *digp, int mode)
/*
	Open a pc display in the given text mode, if possible.
*/
{
	switch(mode) {
	case 0x00:
	case 0x01:
	case 0x02:
	case 0x03:
	case PCMODE_EGA43:
	case PCMODE_VGA50:
		return(pc_OpenText(digp, mode));
	case 0x07:
		return(pc_OpenText(digp, mode));
	default:
		return(FALSE);
	}
}
/* -------------------------------------------------------------------------- */

