/*
	pcramcpp.c

	% Pixmap copy function, extracted from pcramcpy.c

	10/19/88  by Ted.

	OWL-PC 1.2
	Copyright (c) 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 7/14/89 ted	Installed pcdata-> ilmask, ilsize, vbincr.

	 3/28/90 jmd	ansi-fied
	 6/06/90 ted	Added planemask arg to ram_copy stuff for EVGA plane drawing.
*/

#include "pcpriv.h"

/* -------------------------------------------------------------------------- */

void DIGPRIV ram_copypm(opbox *scrboxp, pmap_type pmap, opcoord pmx, opcoord pmy, ramcopy_fptr copy, unsigned planemask)
/*
	Does actual copying between pixmap and display, assuming all clipping is
	taken care of.
*/
{	
	unsigned short bwidth, pmbwidth, pmoffs, vidpos;
	byte *pmpos;

	bwidth = opbox_GetWidth(scrboxp) * pc_pixbits() / 8;

	pmbwidth = pcpmap_bytewidth(pmap);
	pmoffs = pmy * pmbwidth + (pmx * pcpmap_pixbits(pmap) / 8);

	vidpos = (scrboxp->ymin & pcdata->ilmask) * pcdata->ilsize +
				(scrboxp->ymin >> pc_ileave()) * pc_bwidth() +
				scrboxp->xmin * pc_pixbits() / 8;

	if (pc_nplanes() == 1) {
		pmpos = pcpmap_pixbuf(pmap) + pmoffs;
		for (;;) {
			(*copy)(pc_vidseg(), vidpos, pmpos, bwidth);

			if (opbox_GetHeight(scrboxp) <= 1) {
				break;
			}
			scrboxp->ymin += 1;
			pmpos += pmbwidth;

			vidpos += ((scrboxp->ymin & pcdata->ilmask) == 0) ? pcdata->vbincr:
																pcdata->ilsize;
		}
	}
	else {
		for (;;) {
			(*((ramplanecopy_fptr) copy))(pc_vidseg(), vidpos,
						pcpmap_pixbuf(pmap), bwidth, pmoffs, planemask);

			if (opbox_GetHeight(scrboxp) <= 1) {
				break;
			}
			scrboxp->ymin += 1;
			pmoffs += pmbwidth;

			vidpos += ((scrboxp->ymin & pcdata->ilmask) == 0) ? pcdata->vbincr:
																pcdata->ilsize;
		}
	}
}
/* -------------------------------------------------------------------------- */

