/*
	pcramdra.c

	% PC device interface RAM drawing routines

	2/04/89  by Ted.

	OWL-PC 1.2
	Copyright (c) 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 2/04/89 Ted	Removed retrace from Read/Draw Pixmap because no text mode.

	11/05/89 ted	Added pc_roundbyte calls for scrbox x byte alignment.
	 3/28/90 jmd	ansi-fied
	 6/06/90 ted	Added planemask arg to ram_copy stuff for EVGA plane drawing.
*/

#include "pcpriv.h"

/* -------------------------------------------------------------------------- */

void ram_DrawPixmap(ptd_struct *ptd, pmap_type pmap, opbox *pmboxp)
/*
	Copy from the portion of pixmap that is inside 'pmboxp' to the
	display inside of 'ptd->relboxp'.
*/
{
	opbox scrbox;
	opcoord pmx, pmy;

	if (copypm_clip(ptd, pmap, pmboxp, &scrbox, &pmx, &pmy)) {
		if (pc_roundbytex(&scrbox, &pmx)) {
			ram_copypm(&scrbox, pmap, pmx, pmy, ram_memtoseg, 1);
		}
	}
}
/* -------------------------------------------------------------------------- */

void ram_ReadPixmap(ptd_struct *ptd, pmap_type pmap, opbox *pmboxp)
/*
	Copy into the portion of pixmap that is inside 'pmboxp' from the
	display inside of 'ptd->relboxp'.
*/
{
	opbox scrbox;
	opcoord pmx, pmy;

	if (copypm_clip(ptd, pmap, pmboxp, &scrbox, &pmx, &pmy)) {
		if (pc_roundbytex(&scrbox, &pmx)) {
			ram_copypm(&scrbox, pmap, pmx, pmy, ram_segtomem, 1);
		}
	}
}
/* -------------------------------------------------------------------------- */

