/*
	pmapopen.c

	% Pixel map Open requester code.

	5/16/88  by Ted.

	OWL 1.2
	Copyright (c) 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 8/17/88 jmd  	Removed  eNOMEM
	11/02/88 ted 	Made pmap_clip functions calls to opwh_clip functions.
	 2/04/89 ted	Moved real work down into dig level (dpmap_Control)
	 2/23/88 ted	Added copy case.
	 5/09/89 ted	Changed Alloc/Free terms to Open/Close.
	 8/07/89 ted	Split some stuff out to pmapx.c.

	 3/28/90 jmd	ansi-fied
*/

#include "oakhead.h"
#include "disppriv.h"
/* -------------------------------------------------------------------------- */

pmap_type pmap_OpenOnboard(odim width, odim height, boolean onboard, boolean onscreen, opcoord xpos, opcoord ypos)
/*
	Allocates a pixel image map. Returns a pointer to it.
	Returns NULL in case of failure.
*/
{
	pmap_type pmap;
	pmapreq_struct pmapreq;

	pmapreq.width = width;
	pmapreq.height = height;
	pmapreq.onboard = onboard;
	pmapreq.onscreen = onscreen;
	pmapreq.xpos = xpos;
	pmapreq.ypos = ypos;

	pmap_Control(PC_OPENPMAP, &pmapreq, &pmap);
	return(pmap);
}
/* -------------------------------------------------------------------------- */

