/*
	windump.c	8/16/88

	% Window list dumper.

	OWL 1.2
	Copyright (c) 1988, 1989 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 9/02/88 Ted 	Changed for window list names.
	 9/12/88 jmd	Added in and out data to objects

	 3/28/90 jmd	ansi-fied
	 9/05/90 jmd	now uses wmgr_unemployedhead macro
*/

#include "oakhead.h"
#include "disppriv.h"
/* -------------------------------------------------------------------------- */

void win_Dump(char *msg)
/*
	Dump the current window lists to stdout.
*/
{
	win_type win;
	int id;

	printf("-------------------------------------------------------------------------\n");
	printf("Windump: %s\n", msg);

	printf("Employed list.......\n");
	for (win = wmgr_employedhead();
		 win != NULL;
		 win = win_GetBelow(win)) {

		/* get window class id */
		id = obj_GetId(win);

		printf("win %p, above: %p, below: %p, id: %2d, %s \n", 
				(VOID *) win, 
				(VOID *) win_GetAbove(win), 
				(VOID *) win_GetBelow(win),
				id, 
				(win_IsEmployed(win)) ? "employed  " : "unemployed");
	}

	printf("\nUnEmployed list.......\n");
	for (win = wmgr_unemployedhead();
		 win != NULL;
		 win = win_GetBelow(win)) {

		/* get window class id */
		id = obj_GetId(win);

		printf("win %p, above: %p, below: %p, id: %2d, %s\n", 
				(VOID *) win, 
				(VOID *) win_GetAbove(win),
				(VOID *) win_GetBelow(win),
				id, 
				(win_IsEmployed(win)) ? "employed  " : "unemployed");
	}
	printf("\n");
}
/* -------------------------------------------------------------------------- */

