/*
	wingetp.c	3/15/88

	% window position routines.
	by Ted.
	Extracted from winsetp.c

	OWL 1.2
	Copyright (c) 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 3/28/90 jmd	ansi-fied
*/

#include "oakhead.h"
#include "disppriv.h"
/* -------------------------------------------------------------------------- */

void win_GetPixPosition(win_type win, opbox *opboxp)
/*
	Get's the display corners of the window
	and places them into opboxp.
*/
{
	opboxp->xmin = win_GetXmin(win);
	opboxp->ymin = win_GetYmin(win);
	opboxp->xmax = win_GetXmax(win);
	opboxp->ymax = win_GetYmax(win);
}
/* -------------------------------------------------------------------------- */

void win_GetPosition(win_type win, ocbox *ocboxp)
/*
	Gets the display corners of the window and places them into opboxp.
*/
{
	ocboxp->leftcol	 = win_GetLeftCol(win);
	ocboxp->toprow	 = win_GetTopRow(win);
	ocboxp->rightcol = win_GetRightCol(win);
	ocboxp->botrow	 = win_GetBotRow(win);
}
/* -------------------------------------------------------------------------- */

